/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsSqr  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  float fA[10],fB[10];
  float fBha0[10],fBha1[10],fBha2[10];
  float           fBla1[10],fBla2[10];
  float           fBep1[10],fBep2[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  fA[0]=1.0000;
  fA[1]=8.6666;
  fA[2]=16.3333;
  fA[3]=24.0000;
  fA[4]=31.6666;
  fA[5]=39.3333;
  fA[6]=47.0000;
  fA[7]=54.6666;
  fA[8]=62.3333;
  fA[9]=70.0000;
  fB[0]=1.0000000000000000e+000;
  fB[1]=7.5109959500806326e+001;
  fB[2]=2.6677667702682447e+002;
  fB[3]=5.7600000000000000e+002;
  fB[4]=1.0027735095599346e+003;
  fB[5]=1.5471086103661364e+003;
  fB[6]=2.2090000000000000e+003;
  fB[7]=2.9884370761492901e+003;
  fB[8]=3.8854404813988513e+003;
  fB[9]=4.9000000000000000e+003;

  vsSqr(vec_len,fA,fBha0);

  vmsSqr(vec_len,fA,fBep1,VML_EP);

  vmlSetMode(VML_EP);
  vsSqr(vec_len,fA,fBep2);

  vmsSqr(vec_len,fA,fBla1,VML_LA);

  vmlSetMode(VML_LA);
  vsSqr(vec_len,fA,fBla2);

  vmsSqr(vec_len,fA,fBha1,VML_HA);

  vmlSetMode(VML_HA);
  vsSqr(vec_len,fA,fBha2);

  for(i=0;i<10;i++) {
    if(fBha0[i]!=fBha1[i] || fBha1[i]!=fBha2[i]) {
      printf("Error! Difference between vsSqr and vmsSqr in VML_HA mode detected.\n");
      return 1;
    }

    if(fBla1[i]!=fBla2[i]) {
      printf("Error! Difference between vsSqr and vmsSqr in VML_LA mode detected.\n");
      return 1;
    }

    if(fBep1[i]!=fBep2[i]) {
      printf("Error! Difference between vsSqr and vmsSqr in VML_EP mode detected.\n");
      return 1;
    }
  }

  printf("vsSqr test/example program\n\n");
  printf("           Argument                     vsSqr\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",fA[i],fBha0[i]);
    CurRMS=srelerr(fB[i],fBha0[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
