!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdLinearFrac  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dBha0(10)
      real(kind=8) dBha1(10)
      real(kind=8) dBha2(10)
      real(kind=8) dBla1(10)
      real(kind=8) dBla2(10)
      real(kind=8) dBep1(10)
      real(kind=8) dBep2(10)

      real(kind=8) dScale
      real(kind=8) dShift
      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=-10000.0000d+000
      dA( 2)=-7777.7777d+000
      dA( 3)=-5555.5555d+000
      dA( 4)=-3333.3333d+000
      dA( 5)=-1111.1111d+000
      dA( 6)=1111.1111d+000
      dA( 7)=3333.3333d+000
      dA( 8)=5555.5555d+000
      dA( 9)=7777.7777d+000
      dA(10)=10000.0000d+000
      dB( 1)=1.0000000000000000d+000
      dB( 2)=1.0000000000000000d+000
      dB( 3)=1.0000000000000000d+000
      dB( 4)=1.0000000000000000d+000
      dB( 5)=1.0000000000000000d+000
      dB( 6)=1.0000000000000000d+000
      dB( 7)=1.0000000000000000d+000
      dB( 8)=1.0000000000000000d+000
      dB( 9)=1.0000000000000000d+000
      dB(10)=1.0000000000000000d+000
      dScale=1.0000000000000000d+000
      dShift=0.0000000000000000d+000

      call VDLINEARFRAC(vec_len,dA,dA,dScale,dShift,dScale,dShift,dBha0)

      mode=VML_EP
      call VMDLINEARFRAC(vec_len,dA,dA,dScale,dShift,dScale,dShift,     &
     &                                                  dBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VDLINEARFRAC(vec_len,dA,dA,dScale,dShift,dScale,dShift,dBep2)

      mode=VML_LA
      call VMDLINEARFRAC(vec_len,dA,dA,dScale,dShift,dScale,dShift,     &
     &                                                  dBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VDLINEARFRAC(vec_len,dA,dA,dScale,dShift,dScale,dShift,dBla2)

      mode=VML_HA
      call VMDLINEARFRAC(vec_len,dA,dA,dScale,dShift,dScale,dShift,     &
     &                                                  dBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VDLINEARFRAC(vec_len,dA,dA,dScale,dShift,dScale,dShift,dBha2)

      do i=1,10
          if(dBha0(i) .ne. dBha1(i)) then
              print *,"Error! Difference between VDLINEARFRAC and"
              print *," VMDLINEARFRAC in VML_HA mode detected"
              stop 1
          endif
          if(dBha1(i) .ne. dBha2(i)) then
              print *,"Error! Difference between VDLINEARFRAC and"
              print *," VMDLINEARFRAC in VML_HA mode detected"
              stop 1
          endif
          if(dBla1(i) .ne. dBla2(i)) then
              print *,"Error! Difference between VDLINEARFRAC and"
              print *," VMDLINEARFRAC in VML_LA mode detected"
              stop 1
          endif
          if(dBep1(i) .ne. dBep2(i)) then
              print *,"Error! Difference between VDLINEARFRAC and"
              print *," VMDLINEARFRAC in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vdLinearFrac test/example program"
      print *,""
      print 10,"Scalar Parameters: ScaleA = ScaleB = ", dScale
      print 10,"                   ShiftA = ShiftB = ", dShift
      print *,"                       Arguments                      ", &
     &        "      vdLinearFrac"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 11,dA(i),dA(i),dBha0(i)
            CurRMS=drelerr(dB(i),dBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 10,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 10,"Relative accuracy is ",MaxRMS
      endif

10    format(A,F25.16)
11    format(E25.14,E25.14,E25.14)

      end
