!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdSinCos  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dBha0(10)
      real(kind=8) dBha1(10)
      real(kind=8) dBha2(10)
      real(kind=8) dBla1(10)
      real(kind=8) dBla2(10)
      real(kind=8) dBep1(10)
      real(kind=8) dBep2(10)

      real(kind=8) dC(10)
      real(kind=8) dCha0(10)
      real(kind=8) dCha1(10)
      real(kind=8) dCha2(10)
      real(kind=8) dCla1(10)
      real(kind=8) dCla2(10)
      real(kind=8) dCep1(10)
      real(kind=8) dCep2(10)

      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=-10000.0000d+000
      dA( 2)=-7777.7777d+000
      dA( 3)=-5555.5555d+000
      dA( 4)=-3333.3333d+000
      dA( 5)=-1111.1111d+000
      dA( 6)=1111.1111d+000
      dA( 7)=3333.3333d+000
      dA( 8)=5555.5555d+000
      dA( 9)=7777.7777d+000
      dA(10)=10000.0000d+000
      dB( 1)=3.0561438888825215d-001
      dB( 2)=7.2132276994528466d-001
      dB( 3)=-9.3899224902885137d-001
      dB( 4)=1.0330988307550266d-001
      dB( 5)=8.4826444690664649d-001
      dB( 6)=-8.4826444690664649d-001
      dB( 7)=-1.0330988307550266d-001
      dB( 8)=9.3899224902885137d-001
      dB( 9)=-7.2132276994528466d-001
      dB(10)=-3.0561438888825215d-001
      dC( 1)=-9.5215536825901481d-001
      dC( 2)=6.9259906263181004d-001
      dC( 3)=3.4393830299014322d-001
      dC( 4)=-9.9464921859866051d-001
      dC( 5)=5.2957287328011915d-001
      dC( 6)=5.2957287328011915d-001
      dC( 7)=-9.9464921859866051d-001
      dC( 8)=3.4393830299014322d-001
      dC( 9)=6.9259906263181004d-001
      dC(10)=-9.5215536825901481d-001

      call VDSINCOS(vec_len,dA,dBha0,dCha0)

      mode=VML_EP
      call VMDSINCOS(vec_len,dA,dBep1,dCep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VDSINCOS(vec_len,dA,dBep2,dCep2)

      mode=VML_LA
      call VMDSINCOS(vec_len,dA,dBla1,dCla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VDSINCOS(vec_len,dA,dBla2,dCla2)

      mode=VML_HA
      call VMDSINCOS(vec_len,dA,dBha1,dCha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VDSINCOS(vec_len,dA,dBha2,dCha2)

      do i=1,10
          if((dBha0(i) .ne. dBha1(i)).or.(dCha0(i) .ne. dCha1(i))) then
              print *,"Error! Difference between VDSINCOS and"
              print *," VMDSINCOS in VML_HA mode detected"
              stop 1
          endif
          if((dBha1(i) .ne. dBha2(i)).or.(dCha1(i) .ne. dCha2(i))) then
              print *,"Error! Difference between VDSINCOS and"
              print *," VMDSINCOS in VML_HA mode detected"
              stop 1
          endif
          if((dBla1(i) .ne. dBla2(i)).or.(dCla1(i) .ne. dCla2(i))) then
              print *,"Error! Difference between VDSINCOS and"
              print *," VMDSINCOS in VML_LA mode detected"
              stop 1
          endif
          if((dBep1(i) .ne. dBep2(i)).or.(dCep1(i) .ne. dCep2(i))) then
              print *,"Error! Difference between VDSINCOS and"
              print *," VMDSINCOS in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vdSinCos test/example program"
      print *,""
      print *,"           Argument                           vdSinCos"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dBha0(i),dCha0(i)
            CurRMS=drelerr(dB(i),dBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
            CurRMS=drelerr(dC(i),dCha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14,E25.14)
11    format(A,F25.16)

      end
