!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsCdfNormInv  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fBha0(10)
      real(kind=4) fBha1(10)
      real(kind=4) fBha2(10)
      real(kind=4) fBla1(10)
      real(kind=4) fBla2(10)
      real(kind=4) fBep1(10)
      real(kind=4) fBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=0.0001
      fA( 2)=0.1111
      fA( 3)=0.2222
      fA( 4)=0.3333
      fA( 5)=0.4444
      fA( 6)=0.5555
      fA( 7)=0.6666
      fA( 8)=0.7777
      fA( 9)=0.8888
      fA(10)=0.9999
      fB( 1)=-3.71901649184702e+00
      fB( 2)=-1.22069900076286e+00
      fB( 3)=-7.64784275923552e-01
      fB( 4)=-4.30818992209947e-01
      fB( 5)=-1.39822766429026e-01
      fB( 6)= 1.39569603781059e-01
      fB( 7)= 4.30543924329129e-01
      fB( 8)= 7.64448549786968e-01
      fB( 9)= 1.22017128461138e+00
      fB(10)= 3.71897456876537e+00

      call VSCDFNORMINV(vec_len,fA,fBha0)

      mode=VML_EP
      call VMSCDFNORMINV(vec_len,fA,fBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VSCDFNORMINV(vec_len,fA,fBep2)

      mode=VML_LA
      call VMSCDFNORMINV(vec_len,fA,fBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VSCDFNORMINV(vec_len,fA,fBla2)

      mode=VML_HA
      call VMSCDFNORMINV(vec_len,fA,fBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VSCDFNORMINV(vec_len,fA,fBha2)

      do i=1,10
          if(fBha0(i) .ne. fBha1(i)) then
              print *,"Error! Difference between VSCDFNORMINV and"
              print *," VMSCDFNORMINV in VML_HA mode detected"
              stop 1
          endif
          if(fBha1(i) .ne. fBha2(i)) then
              print *,"Error! Difference between VSCDFNORMINV and"
              print *," VMSCDFNORMINV in VML_HA mode detected"
              stop 1
          endif
          if(fBla1(i) .ne. fBla2(i)) then
              print *,"Error! Difference between VSCDFNORMINV and"
              print *," VMSCDFNORMINV in VML_LA mode detected"
              stop 1
          endif
          if(fBep1(i) .ne. fBep2(i)) then
              print *,"Error! Difference between VSCDFNORMINV and"
              print *," VMSCDFNORMINV in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vsCdfNormInv test/example program"
      print *,""
      print *,"           Argument                     vsCdfNormInv"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fBha0(i)
            CurRMS=srelerr(fB(i),fBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
