!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsInvCbrt  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fBha0(10)
      real(kind=4) fBha1(10)
      real(kind=4) fBha2(10)
      real(kind=4) fBla1(10)
      real(kind=4) fBla2(10)
      real(kind=4) fBep1(10)
      real(kind=4) fBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=0.1000
      fA( 2)=1111.2000
      fA( 3)=2222.2998
      fA( 4)=3333.3999
      fA( 5)=4444.5000
      fA( 6)=5555.6001
      fA( 7)=6666.7002
      fA( 8)=7777.7998
      fA( 9)=8888.9004
      fA(10)=10000.0000
      fB( 1)=2.1544346793306910e+000
      fB( 2)=9.6546365373649815e-002
      fB( 3)=7.6630051477486791e-002
      fB( 4)=6.6942849379259678e-002
      fB( 5)=6.0821766532762715e-002
      fB( 6)=5.6462010837070649e-002
      fB( 7)=5.3132839385672183e-002
      fB( 8)=5.0471678326454113e-002
      fB( 9)=4.8274448408791727e-002
      fB(10)=4.6415888336127795e-002

      call VSINVCBRT(vec_len,fA,fBha0)

      mode=VML_EP
      call VMSINVCBRT(vec_len,fA,fBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VSINVCBRT(vec_len,fA,fBep2)

      mode=VML_LA
      call VMSINVCBRT(vec_len,fA,fBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VSINVCBRT(vec_len,fA,fBla2)

      mode=VML_HA
      call VMSINVCBRT(vec_len,fA,fBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VSINVCBRT(vec_len,fA,fBha2)

      do i=1,10
          if(fBha0(i) .ne. fBha1(i)) then
              print *,"Error! Difference between VSINVCBRT and"
              print *," VMSINVCBRT in VML_HA mode detected"
              stop 1
          endif
          if(fBha1(i) .ne. fBha2(i)) then
              print *,"Error! Difference between VSINVCBRT and"
              print *," VMSINVCBRT in VML_HA mode detected"
              stop 1
          endif
          if(fBla1(i) .ne. fBla2(i)) then
              print *,"Error! Difference between VSINVCBRT and"
              print *," VMSINVCBRT in VML_LA mode detected"
              stop 1
          endif
          if(fBep1(i) .ne. fBep2(i)) then
              print *,"Error! Difference between VSINVCBRT and"
              print *," VMSINVCBRT in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vsInvCbrt test/example program"
      print *,""
      print *,"           Argument                     vsInvCbrt"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fBha0(i)
            CurRMS=srelerr(fB(i),fBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
