!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsSinCos  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fBha0(10)
      real(kind=4) fBha1(10)
      real(kind=4) fBha2(10)
      real(kind=4) fBla1(10)
      real(kind=4) fBla2(10)
      real(kind=4) fBep1(10)
      real(kind=4) fBep2(10)

      real(kind=4) fC(10)
      real(kind=4) fCha0(10)
      real(kind=4) fCha1(10)
      real(kind=4) fCha2(10)
      real(kind=4) fCla1(10)
      real(kind=4) fCla2(10)
      real(kind=4) fCep1(10)
      real(kind=4) fCep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=-10000.0000
      fA( 2)=-7777.7778
      fA( 3)=-5555.5557
      fA( 4)=-3333.3333
      fA( 5)=-1111.1111
      fA( 6)=1111.1111
      fA( 7)=3333.3333
      fA( 8)=5555.5557
      fA( 9)=7777.7778
      fA(10)=10000.0000
      fB( 1)=3.0561438888825215e-001
      fB( 2)=7.2123131893817349e-001
      fB( 3)=-9.3904866376910323e-001
      fB( 4)=1.0326209316981849e-001
      fB( 5)=8.4827292823844636e-001
      fB( 6)=-8.4827292823844636e-001
      fB( 7)=-1.0326209316981849e-001
      fB( 8)=9.3904866376910323e-001
      fB( 9)=-7.2123131893817349e-001
      fB(10)=-3.0561438888825215e-001
      fC( 1)=-9.5215536825901481e-001
      fC( 2)=6.9269429374198155e-001
      fC( 3)=3.4378424494653864e-001
      fC( 4)=-9.9465418116759940e-001
      fC( 5)=5.2955928772685279e-001
      fC( 6)=5.2955928772685279e-001
      fC( 7)=-9.9465418116759940e-001
      fC( 8)=3.4378424494653864e-001
      fC( 9)=6.9269429374198155e-001
      fC(10)=-9.5215536825901481e-001

      call VSSINCOS(vec_len,fA,fBha0,fCha0)

      mode=VML_EP
      call VMSSINCOS(vec_len,fA,fBep1,fCep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VSSINCOS(vec_len,fA,fBep2,fCep2)

      mode=VML_LA
      call VMSSINCOS(vec_len,fA,fBla1,fCla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VSSINCOS(vec_len,fA,fBla2,fCla2)

      mode=VML_HA
      call VMSSINCOS(vec_len,fA,fBha1,fCha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VSSINCOS(vec_len,fA,fBha2,fCha2)

      do i=1,10
          if((fBha0(i) .ne. fBha1(i)).or.(fCha0(i) .ne. fCha1(i))) then
              print *,"Error! Difference between VSSINCOS and"
              print *," VMSSINCOS in VML_HA mode detected"
              stop 1
          endif
          if((fBha1(i) .ne. fBha2(i)).or.(fCha1(i) .ne. fCha2(i))) then
              print *,"Error! Difference between VSSINCOS and"
              print *," VMSSINCOS in VML_HA mode detected"
              stop 1
          endif
          if((fBla1(i) .ne. fBla2(i)).or.(fCla1(i) .ne. fCla2(i))) then
              print *,"Error! Difference between VSSINCOS and"
              print *," VMSSINCOS in VML_LA mode detected"
              stop 1
          endif
          if((fBep1(i) .ne. fBep2(i)).or.(fCep1(i) .ne. fCep2(i))) then
              print *,"Error! Difference between VSSINCOS and"
              print *," VMSSINCOS in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vsSinCos test/example program"
      print *,""
      print *,"           Argument                           vsSinCos"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fBha0(i),fCha0(i)
            CurRMS=srelerr(fB(i),fBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
            CurRMS=srelerr(fC(i),fCha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14,E25.14)
11    format(A,F25.16)

      end
