!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcDiv  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zBha0(10)
      complex(kind=8) zBha1(10)
      complex(kind=8) zBha2(10)
      complex(kind=8) zBla1(10)
      complex(kind=8) zBla2(10)
      complex(kind=8) zBep1(10)
      complex(kind=8) zBep2(10)

      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(-10000.0000d+000,10000.0000d+000)
      zA( 2)=(-7777.7777d+000,7777.7777d+000)
      zA( 3)=(-5555.5555d+000,5555.5555d+000)
      zA( 4)=(-3333.3333d+000,3333.3333d+000)
      zA( 5)=(-1111.1111d+000,1111.1111d+000)
      zA( 6)=(1111.1111d+000,-1111.1111d+000)
      zA( 7)=(3333.3333d+000,-3333.3333d+000)
      zA( 8)=(5555.5555d+000,-5555.5555d+000)
      zA( 9)=(7777.7777d+000,-7777.7777d+000)
      zA(10)=(10000.0000d+000,-10000.0000d+000)
      zB( 1)=(1.0000000000000000d+000,0.0000000000000000d+000)
      zB( 2)=(1.0000000000000000d+000,0.0000000000000000d+000)
      zB( 3)=(9.9999999999999989d-001,0.0000000000000000d+000)
      zB( 4)=(1.0000000000000000d+000,0.0000000000000000d+000)
      zB( 5)=(1.0000000000000000d+000,0.0000000000000000d+000)
      zB( 6)=(1.0000000000000000d+000,0.0000000000000000d+000)
      zB( 7)=(1.0000000000000000d+000,0.0000000000000000d+000)
      zB( 8)=(9.9999999999999989d-001,0.0000000000000000d+000)
      zB( 9)=(1.0000000000000000d+000,0.0000000000000000d+000)
      zB(10)=(1.0000000000000000d+000,0.0000000000000000d+000)

      call VZDIV(vec_len,zA,zA,zBha0)

      mode=VML_EP
      call VMZDIV(vec_len,zA,zA,zBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VZDIV(vec_len,zA,zA,zBep2)

      mode=VML_LA
      call VMZDIV(vec_len,zA,zA,zBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VZDIV(vec_len,zA,zA,zBla2)

      mode=VML_HA
      call VMZDIV(vec_len,zA,zA,zBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VZDIV(vec_len,zA,zA,zBha2)

      do i=1,10
          if(zBha0(i) .ne. zBha1(i)) then
              print *,"Error! Difference between VZDIV and"
              print *," VMZDIV in VML_HA mode detected"
              stop 1
          endif
          if(zBha1(i) .ne. zBha2(i)) then
              print *,"Error! Difference between VZDIV and"
              print *," VMZDIV in VML_HA mode detected"
              stop 1
          endif
          if(zBla1(i) .ne. zBla2(i)) then
              print *,"Error! Difference between VZDIV and"
              print *," VMZDIV in VML_LA mode detected"
              stop 1
          endif
          if(zBep1(i) .ne. zBep2(i)) then
              print *,"Error! Difference between VZDIV and"
              print *," VMZDIV in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vzDiv test/example program"
      print *,""
      print *,"                    Arguments                         ", &
     &        "      vzDiv"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),zA(i),"    ",zBha0(i)
            CurRMS=zrelerr(zB(i),zBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E12.3,E12.3,E12.3,E12.3,A5,E12.3,E12.3)
11    format(A,F25.16)

      end
