/*******************************************************************************
!                             INTEL CONFIDENTIAL
!   Copyright(C) 1999-2010 Intel Corporation. All Rights Reserved.
!   The source code contained  or  described herein and all documents related to
!   the source code ("Material") are owned by Intel Corporation or its suppliers
!   or licensors.  Title to the  Material remains with  Intel Corporation or its
!   suppliers and licensors. The Material contains trade secrets and proprietary
!   and  confidential  information of  Intel or its suppliers and licensors. The
!   Material  is  protected  by  worldwide  copyright  and trade secret laws and
!   treaty  provisions. No part of the Material may be used, copied, reproduced,
!   modified, published, uploaded, posted, transmitted, distributed or disclosed
!   in any way without Intel's prior express written permission.
!   No license  under any  patent, copyright, trade secret or other intellectual
!   property right is granted to or conferred upon you by disclosure or delivery
!   of the Materials,  either expressly, by implication, inducement, estoppel or
!   otherwise.  Any  license  under  such  intellectual property  rights must be
!   express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!      Intel(R) Math Kernel Library (MKL) interface for BLACS routines
!******************************************************************************/

#ifndef _MKL_BLACS_H_
#define _MKL_BLACS_H_

#include "mkl_types.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* <name>_ declarations */

void	igamx2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);
void	sgamx2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);
void	dgamx2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);
void	cgamx2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);
void	zgamx2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);

void	igamn2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);
void	sgamn2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);
void	dgamn2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);
void	cgamn2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);
void	zgamn2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rA, MKL_INT *cA, MKL_INT *ldia, MKL_INT *rdest, MKL_INT *cdest);

void	igsum2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	sgsum2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	dgsum2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	cgsum2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	zgsum2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);

void	igesd2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	sgesd2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	dgesd2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	cgesd2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	zgesd2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);

void	itrsd2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	strsd2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	dtrsd2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	ctrsd2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);
void	ztrsd2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rdest, MKL_INT *cdest);

void	igerv2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	sgerv2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	dgerv2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	cgerv2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	zgerv2d_(MKL_INT *ConTxt, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);

void	itrrv2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	strrv2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	dtrrv2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	ctrrv2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	ztrrv2d_(MKL_INT *ConTxt, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);

void	igebs2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda);
void	sgebs2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda);
void	dgebs2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda);
void	cgebs2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda);
void	zgebs2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda);

void	itrbs2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda);
void	strbs2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda);
void	dtrbs2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda);
void	ctrbs2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda);
void	ztrbs2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda);

void	igebr2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	sgebr2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	dgebr2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	cgebr2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	zgebr2d_(MKL_INT *ConTxt, char *scope, char *top, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);

void	itrbr2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, MKL_INT *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	strbr2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	dtrbr2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	ctrbr2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, float *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);
void	ztrbr2d_(MKL_INT *ConTxt, char *scope, char *top, char *uplo, char *diag, MKL_INT *m, MKL_INT *n, double *A, MKL_INT *lda, MKL_INT *rsrc, MKL_INT *csrc);

void	blacs_pinfo_(MKL_INT *mypnum, MKL_INT *nprocs);
void	blacs_setup_(MKL_INT *mypnum, MKL_INT *nprocs);
void	blacs_get_(MKL_INT *ConTxt, MKL_INT *what, MKL_INT *val);
void	blacs_set_(MKL_INT *ConTxt, MKL_INT *what, MKL_INT *val);
void	blacs_gridinit_(MKL_INT *ConTxt, char *order, MKL_INT *nprow, MKL_INT *npcol);
void	blacs_gridmap_(MKL_INT *ConTxt, MKL_INT *usermap, MKL_INT *ldup, MKL_INT *nprow0, MKL_INT *npcol0);

void	blacs_freebuff_(MKL_INT *ConTxt, MKL_INT *Wait);
void	blacs_gridexit_(MKL_INT *ConTxt);
void	blacs_abort_(MKL_INT *ConTxt, MKL_INT *ErrNo);
void	blacs_exit_(MKL_INT *NotDone);

void	blacs_gridinfo_(MKL_INT *ConTxt, MKL_INT *nprow, MKL_INT *npcol, MKL_INT *myrow, MKL_INT *mycol);
MKL_INT	blacs_pnum_(MKL_INT *ConTxt, MKL_INT *prow, MKL_INT *pcol);
void	blacs_pcoord_(MKL_INT *ConTxt, MKL_INT *nodenum, MKL_INT *prow, MKL_INT *pcol);

void	blacs_barrier_(MKL_INT *ConTxt, char *scope);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _MKL_BLACS_H_ */
