! file: mkl_vsl.f77
!
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2006-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!++
!  Fortran 77 VSL interface.
!--

!++
!  Definitions for VSL functions return values (errors, warnings)
!--

!  "No error" status
      INTEGER*4 VSL_STATUS_OK
      INTEGER*4 VSL_ERROR_OK
      PARAMETER (VSL_STATUS_OK = 0)
      PARAMETER (VSL_ERROR_OK  = 0)

!  Common errors (-1..-999)
      INTEGER*4 VSL_ERROR_FEATURE_NOT_IMPLEMENTED
      INTEGER*4 VSL_ERROR_UNKNOWN
      INTEGER*4 VSL_ERROR_BADARGS
      INTEGER*4 VSL_ERROR_MEM_FAILURE
      INTEGER*4 VSL_ERROR_NULL_PTR
      INTEGER*4 VSL_ERROR_CPU_NOT_SUPPORTED
      PARAMETER (VSL_ERROR_FEATURE_NOT_IMPLEMENTED = -1)
      PARAMETER (VSL_ERROR_UNKNOWN                 = -2)
      PARAMETER (VSL_ERROR_BADARGS                 = -3)
      PARAMETER (VSL_ERROR_MEM_FAILURE             = -4)
      PARAMETER (VSL_ERROR_NULL_PTR                = -5)
      PARAMETER (VSL_ERROR_CPU_NOT_SUPPORTED       = -6)

!  RNG errors (-1000..-1999)
!  brng errors
      INTEGER*4 VSL_RNG_ERROR_INVALID_BRNG_INDEX
      INTEGER*4 VSL_RNG_ERROR_LEAPFROG_UNSUPPORTED
      INTEGER*4 VSL_RNG_ERROR_SKIPAHEAD_UNSUPPORTED
      INTEGER*4 VSL_RNG_ERROR_BRNGS_INCOMPATIBLE
      INTEGER*4 VSL_RNG_ERROR_BAD_STREAM
      INTEGER*4 VSL_RNG_ERROR_BRNG_TABLE_FULL
      INTEGER*4 VSL_RNG_ERROR_BAD_STREAM_STATE_SIZE
      INTEGER*4 VSL_RNG_ERROR_BAD_WORD_SIZE
      INTEGER*4 VSL_RNG_ERROR_BAD_NSEEDS
      INTEGER*4 VSL_RNG_ERROR_BAD_NBITS
      INTEGER*4 VSL_RNG_ERROR_QRNG_PERIOD_ELAPSED
      INTEGER*4 VSL_RNG_ERROR_LEAPFROG_NSTREAMS_TOO_BIG
      PARAMETER (VSL_RNG_ERROR_INVALID_BRNG_INDEX        = -1000)
      PARAMETER (VSL_RNG_ERROR_LEAPFROG_UNSUPPORTED      = -1002)
      PARAMETER (VSL_RNG_ERROR_SKIPAHEAD_UNSUPPORTED     = -1003)
      PARAMETER (VSL_RNG_ERROR_BRNGS_INCOMPATIBLE        = -1005)
      PARAMETER (VSL_RNG_ERROR_BAD_STREAM                = -1006)
      PARAMETER (VSL_RNG_ERROR_BRNG_TABLE_FULL           = -1007)
      PARAMETER (VSL_RNG_ERROR_BAD_STREAM_STATE_SIZE     = -1008)
      PARAMETER (VSL_RNG_ERROR_BAD_WORD_SIZE             = -1009)
      PARAMETER (VSL_RNG_ERROR_BAD_NSEEDS                = -1010)
      PARAMETER (VSL_RNG_ERROR_BAD_NBITS                 = -1011)
      PARAMETER (VSL_RNG_ERROR_QRNG_PERIOD_ELAPSED       = -1012)
      PARAMETER (VSL_RNG_ERROR_LEAPFROG_NSTREAMS_TOO_BIG = -1013)

! abstract stream related errors
      INTEGER*4 VSL_RNG_ERROR_BAD_UPDATE
      INTEGER*4 VSL_RNG_ERROR_NO_NUMBERS
      INTEGER*4 VSL_RNG_ERROR_INVALID_ABSTRACT_STREAM
      PARAMETER (VSL_RNG_ERROR_BAD_UPDATE              = -1120)
      PARAMETER (VSL_RNG_ERROR_NO_NUMBERS              = -1121)
      PARAMETER (VSL_RNG_ERROR_INVALID_ABSTRACT_STREAM = -1122)

! read/write stream to file errors
      INTEGER*4 VSL_RNG_ERROR_FILE_CLOSE
      INTEGER*4 VSL_RNG_ERROR_FILE_OPEN
      INTEGER*4 VSL_RNG_ERROR_FILE_WRITE
      INTEGER*4 VSL_RNG_ERROR_FILE_READ

      INTEGER*4 VSL_RNG_ERROR_BAD_FILE_FORMAT
      INTEGER*4 VSL_RNG_ERROR_UNSUPPORTED_FILE_VER
      PARAMETER (VSL_RNG_ERROR_FILE_CLOSE           = -1100)
      PARAMETER (VSL_RNG_ERROR_FILE_OPEN            = -1101)
      PARAMETER (VSL_RNG_ERROR_FILE_WRITE           = -1102)
      PARAMETER (VSL_RNG_ERROR_FILE_READ            = -1103)

      PARAMETER (VSL_RNG_ERROR_BAD_FILE_FORMAT      = -1110)
      PARAMETER (VSL_RNG_ERROR_UNSUPPORTED_FILE_VER = -1111)

!++
! BEGINNING OF DEPRECATED SECTION
!--
!  RNG errors (-1000..-1999)
!  brng errors
      INTEGER*4 VSL_ERROR_INVALID_BRNG_INDEX
      INTEGER*4 VSL_ERROR_LEAPFROG_UNSUPPORTED
      INTEGER*4 VSL_ERROR_SKIPAHEAD_UNSUPPORTED
      INTEGER*4 VSL_ERROR_BRNGS_INCOMPATIBLE
      INTEGER*4 VSL_ERROR_BAD_STREAM
      INTEGER*4 VSL_ERROR_BRNG_TABLE_FULL
      INTEGER*4 VSL_ERROR_BAD_STREAM_STATE_SIZE
      INTEGER*4 VSL_ERROR_BAD_WORD_SIZE
      INTEGER*4 VSL_ERROR_BAD_NSEEDS
      INTEGER*4 VSL_ERROR_BAD_NBITS
      INTEGER*4 VSL_QRNG_PERIOD_ELAPSED
      INTEGER*4 VSL_ERROR_LEAPFROG_NSTREAMS_TOO_BIG
      PARAMETER (VSL_ERROR_INVALID_BRNG_INDEX        = -1000)
      PARAMETER (VSL_ERROR_LEAPFROG_UNSUPPORTED      = -1002)
      PARAMETER (VSL_ERROR_SKIPAHEAD_UNSUPPORTED     = -1003)
      PARAMETER (VSL_ERROR_BRNGS_INCOMPATIBLE        = -1005)
      PARAMETER (VSL_ERROR_BAD_STREAM                = -1006)
      PARAMETER (VSL_ERROR_BRNG_TABLE_FULL           = -1007)
      PARAMETER (VSL_ERROR_BAD_STREAM_STATE_SIZE     = -1008)
      PARAMETER (VSL_ERROR_BAD_WORD_SIZE             = -1009)
      PARAMETER (VSL_ERROR_BAD_NSEEDS                = -1010)
      PARAMETER (VSL_ERROR_BAD_NBITS                 = -1011)
      PARAMETER (VSL_QRNG_PERIOD_ELAPSED             = -1012)
      PARAMETER (VSL_ERROR_LEAPFROG_NSTREAMS_TOO_BIG = -1013)

! abstract stream related errors
      INTEGER*4 VSL_ERROR_BAD_UPDATE
      INTEGER*4 VSL_ERROR_NO_NUMBERS
      INTEGER*4 VSL_ERROR_INVALID_ABSTRACT_STREAM
      PARAMETER (VSL_ERROR_BAD_UPDATE              = -1120)
      PARAMETER (VSL_ERROR_NO_NUMBERS              = -1121)
      PARAMETER (VSL_ERROR_INVALID_ABSTRACT_STREAM = -1122)

! read/write stream to file errors
      INTEGER*4 VSL_ERROR_FILE_CLOSE
      INTEGER*4 VSL_ERROR_FILE_OPEN
      INTEGER*4 VSL_ERROR_FILE_WRITE
      INTEGER*4 VSL_ERROR_FILE_READ

      INTEGER*4 VSL_ERROR_BAD_FILE_FORMAT
      INTEGER*4 VSL_ERROR_UNSUPPORTED_FILE_VER
      PARAMETER (VSL_ERROR_FILE_CLOSE           = -1100)
      PARAMETER (VSL_ERROR_FILE_OPEN            = -1101)
      PARAMETER (VSL_ERROR_FILE_WRITE           = -1102)
      PARAMETER (VSL_ERROR_FILE_READ            = -1103)

      PARAMETER (VSL_ERROR_BAD_FILE_FORMAT      = -1110)
      PARAMETER (VSL_ERROR_UNSUPPORTED_FILE_VER = -1111)
!++
! END OF DEPRECATED SECTION
!--

! Convolution/correlation errors
      INTEGER*4 VSL_CC_ERROR_NOT_IMPLEMENTED
      INTEGER*4 VSL_CC_ERROR_ALLOCATION_FAILURE
      INTEGER*4 VSL_CC_ERROR_BAD_DESCRIPTOR
      INTEGER*4 VSL_CC_ERROR_SERVICE_FAILURE
      INTEGER*4 VSL_CC_ERROR_EDIT_FAILURE
      INTEGER*4 VSL_CC_ERROR_EDIT_PROHIBITED
      INTEGER*4 VSL_CC_ERROR_COMMIT_FAILURE
      INTEGER*4 VSL_CC_ERROR_COPY_FAILURE
      INTEGER*4 VSL_CC_ERROR_DELETE_FAILURE
      INTEGER*4 VSL_CC_ERROR_BAD_ARGUMENT
      INTEGER*4 VSL_CC_ERROR_DIMS
      INTEGER*4 VSL_CC_ERROR_START
      INTEGER*4 VSL_CC_ERROR_DECIMATION
      INTEGER*4 VSL_CC_ERROR_XSHAPE
      INTEGER*4 VSL_CC_ERROR_YSHAPE
      INTEGER*4 VSL_CC_ERROR_ZSHAPE
      INTEGER*4 VSL_CC_ERROR_XSTRIDE
      INTEGER*4 VSL_CC_ERROR_YSTRIDE
      INTEGER*4 VSL_CC_ERROR_ZSTRIDE
      INTEGER*4 VSL_CC_ERROR_X
      INTEGER*4 VSL_CC_ERROR_Y
      INTEGER*4 VSL_CC_ERROR_Z
      INTEGER*4 VSL_CC_ERROR_JOB
      INTEGER*4 VSL_CC_ERROR_KIND
      INTEGER*4 VSL_CC_ERROR_MODE
      INTEGER*4 VSL_CC_ERROR_TYPE
      INTEGER*4 VSL_CC_ERROR_PRECISION
      INTEGER*4 VSL_CC_ERROR_EXTERNAL_PRECISION
      INTEGER*4 VSL_CC_ERROR_INTERNAL_PRECISION
      INTEGER*4 VSL_CC_ERROR_METHOD
      INTEGER*4 VSL_CC_ERROR_OTHER
      PARAMETER (VSL_CC_ERROR_NOT_IMPLEMENTED    = -2000)
      PARAMETER (VSL_CC_ERROR_ALLOCATION_FAILURE = -2001)
      PARAMETER (VSL_CC_ERROR_BAD_DESCRIPTOR     = -2200)
      PARAMETER (VSL_CC_ERROR_SERVICE_FAILURE    = -2210)
      PARAMETER (VSL_CC_ERROR_EDIT_FAILURE       = -2211)
      PARAMETER (VSL_CC_ERROR_EDIT_PROHIBITED    = -2212)
      PARAMETER (VSL_CC_ERROR_COMMIT_FAILURE     = -2220)
      PARAMETER (VSL_CC_ERROR_COPY_FAILURE       = -2230)
      PARAMETER (VSL_CC_ERROR_DELETE_FAILURE     = -2240)
      PARAMETER (VSL_CC_ERROR_BAD_ARGUMENT       = -2300)
      PARAMETER (VSL_CC_ERROR_DIMS               = -2301)
      PARAMETER (VSL_CC_ERROR_START              = -2302)
      PARAMETER (VSL_CC_ERROR_DECIMATION         = -2303)
      PARAMETER (VSL_CC_ERROR_XSHAPE             = -2311)
      PARAMETER (VSL_CC_ERROR_YSHAPE             = -2312)
      PARAMETER (VSL_CC_ERROR_ZSHAPE             = -2313)
      PARAMETER (VSL_CC_ERROR_XSTRIDE            = -2321)
      PARAMETER (VSL_CC_ERROR_YSTRIDE            = -2322)
      PARAMETER (VSL_CC_ERROR_ZSTRIDE            = -2323)
      PARAMETER (VSL_CC_ERROR_X                  = -2331)
      PARAMETER (VSL_CC_ERROR_Y                  = -2332)
      PARAMETER (VSL_CC_ERROR_Z                  = -2333)
      PARAMETER (VSL_CC_ERROR_JOB                = -2100)
      PARAMETER (VSL_CC_ERROR_KIND               = -2110)
      PARAMETER (VSL_CC_ERROR_MODE               = -2120)
      PARAMETER (VSL_CC_ERROR_TYPE               = -2130)
      PARAMETER (VSL_CC_ERROR_PRECISION          = -2400)
      PARAMETER (VSL_CC_ERROR_EXTERNAL_PRECISION = -2141)
      PARAMETER (VSL_CC_ERROR_INTERNAL_PRECISION = -2142)
      PARAMETER (VSL_CC_ERROR_METHOD             = -2400)
      PARAMETER (VSL_CC_ERROR_OTHER              = -2800)

!++
! SUMMARY STATTISTICS ERROR/WARNING CODES
!--

!  Warnings
      INTEGER*4 VSL_SS_NOT_FULL_RANK_MATRIX
      INTEGER*4 VSL_SS_SEMIDEFINITE_COR
      PARAMETER (VSL_SS_NOT_FULL_RANK_MATRIX     = 4028)
      PARAMETER (VSL_SS_SEMIDEFINITE_COR         = 4029)

!  Errors and messages (-4000..-4999)
      INTEGER*4 VSL_SS_ERROR_ALLOCATION_FAILURE
      INTEGER*4 VSL_SS_ERROR_BAD_DIMEN
      INTEGER*4 VSL_SS_ERROR_BAD_OBSERV_N
      INTEGER*4 VSL_SS_ERROR_STORAGE_NOT_SUPPORTED
      INTEGER*4 VSL_SS_ERROR_BAD_INDC_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_WEIGHTS
      INTEGER*4 VSL_SS_ERROR_BAD_MEAN_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_2R_MOM_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_3R_MOM_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_4R_MOM_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_2C_MOM_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_3C_MOM_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_4C_MOM_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_KURTOSIS_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_SKEWNESS_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MIN_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MAX_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_VARIATION_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_COV_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_COR_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_ACCUM_WEIGHT_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_QUANT_ORDER_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_QUANT_ORDER
      INTEGER*4 VSL_SS_ERROR_BAD_QUANT_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_ORDER_STATS_ADDR
      INTEGER*4 VSL_SS_ERROR_MOMORDER_NOT_SUPPORTED
      INTEGER*4 VSL_SS_ERROR_ALL_OBSERVS_OUTLIERS
      INTEGER*4 VSL_SS_ERROR_BAD_ROBUST_COV_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_ROBUST_MEAN_ADDR
      INTEGER*4 VSL_SS_ERROR_METHOD_NOT_SUPPORTED
      INTEGER*4 VSL_SS_ERROR_BAD_GROUP_INDC_ADDR
      INTEGER*4 VSL_SS_ERROR_NULL_TASK_DESCRIPTOR
      INTEGER*4 VSL_SS_ERROR_BAD_OBSERV_ADDR
      INTEGER*4 VSL_SS_ERROR_SINGULAR_COV
      INTEGER*4 VSL_SS_ERROR_BAD_POOLED_COV_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_POOLED_MEAN_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_GROUP_COV_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_GROUP_MEAN_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_GROUP_INDC
      INTEGER*4 VSL_SS_ERROR_BAD_OUTLIERS_PARAMS_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_OUTLIERS_PARAMS_N_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_OUTLIERS_WEIGHTS_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_ROBUST_COV_PARAMS_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_ROBUST_COV_PARAMS_N_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_STORAGE_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_PARTIAL_COV_IDX_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_PARTIAL_COV_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_PARTIAL_COR_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_PARAMS_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_PARAMS_N_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_BAD_PARAMS_N
      INTEGER*4 VSL_SS_ERROR_BAD_MI_PARAMS
      INTEGER*4 VSL_SS_ERROR_BAD_MI_INIT_ESTIMATES_N_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_INIT_ESTIMATES_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_SIMUL_VALS_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_SIMUL_VALS_N_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_ESTIMATES_N_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_ESTIMATES_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_SIMUL_VALS_N
      INTEGER*4 VSL_SS_ERROR_BAD_MI_ESTIMATES_N
      INTEGER*4 VSL_SS_ERROR_BAD_MI_OUTPUT_PARAMS
      INTEGER*4 VSL_SS_ERROR_BAD_MI_PRIOR_N_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_PRIOR_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_MI_MISSING_VALS_N
      INTEGER*4 VSL_SS_ERROR_BAD_STREAM_QUANT_PARAMS_N_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_STREAM_QUANT_PARAMS_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_STREAM_QUANT_PARAMS_N
      INTEGER*4 VSL_SS_ERROR_BAD_STREAM_QUANT_PARAMS
      INTEGER*4 VSL_SS_ERROR_BAD_STREAM_QUANT_ORDER_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_STREAM_QUANT_ORDER
      INTEGER*4 VSL_SS_ERROR_BAD_STREAM_QUANT_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_PARAMTR_COR_ADDR
      INTEGER*4 VSL_SS_ERROR_BAD_COR
      INTEGER*4 VSL_SS_ERROR_BAD_PARTIAL_COV_IDX

      PARAMETER (VSL_SS_ERROR_ALLOCATION_FAILURE             =-4000)
      PARAMETER (VSL_SS_ERROR_BAD_DIMEN                      =-4001)
      PARAMETER (VSL_SS_ERROR_BAD_OBSERV_N                   =-4002)
      PARAMETER (VSL_SS_ERROR_STORAGE_NOT_SUPPORTED          =-4003)
      PARAMETER (VSL_SS_ERROR_BAD_INDC_ADDR                  =-4004)
      PARAMETER (VSL_SS_ERROR_BAD_WEIGHTS                    =-4005)
      PARAMETER (VSL_SS_ERROR_BAD_MEAN_ADDR                  =-4006)
      PARAMETER (VSL_SS_ERROR_BAD_2R_MOM_ADDR                =-4007)
      PARAMETER (VSL_SS_ERROR_BAD_3R_MOM_ADDR                =-4008)
      PARAMETER (VSL_SS_ERROR_BAD_4R_MOM_ADDR                =-4009)
      PARAMETER (VSL_SS_ERROR_BAD_2C_MOM_ADDR                =-4010)
      PARAMETER (VSL_SS_ERROR_BAD_3C_MOM_ADDR                =-4011)
      PARAMETER (VSL_SS_ERROR_BAD_4C_MOM_ADDR                =-4012)
      PARAMETER (VSL_SS_ERROR_BAD_KURTOSIS_ADDR              =-4013)
      PARAMETER (VSL_SS_ERROR_BAD_SKEWNESS_ADDR              =-4014)
      PARAMETER (VSL_SS_ERROR_BAD_MIN_ADDR                   =-4015)
      PARAMETER (VSL_SS_ERROR_BAD_MAX_ADDR                   =-4016)
      PARAMETER (VSL_SS_ERROR_BAD_VARIATION_ADDR             =-4017)
      PARAMETER (VSL_SS_ERROR_BAD_COV_ADDR                   =-4018)
      PARAMETER (VSL_SS_ERROR_BAD_COR_ADDR                   =-4019)
      PARAMETER (VSL_SS_ERROR_BAD_ACCUM_WEIGHT_ADDR          =-4020)
      PARAMETER (VSL_SS_ERROR_BAD_QUANT_ORDER_ADDR           =-4021)
      PARAMETER (VSL_SS_ERROR_BAD_QUANT_ORDER                =-4022)
      PARAMETER (VSL_SS_ERROR_BAD_QUANT_ADDR                 =-4023)
      PARAMETER (VSL_SS_ERROR_BAD_ORDER_STATS_ADDR           =-4024)
      PARAMETER (VSL_SS_ERROR_MOMORDER_NOT_SUPPORTED         =-4025)
      PARAMETER (VSL_SS_ERROR_ALL_OBSERVS_OUTLIERS           =-4026)
      PARAMETER (VSL_SS_ERROR_BAD_ROBUST_COV_ADDR            =-4027)
      PARAMETER (VSL_SS_ERROR_BAD_ROBUST_MEAN_ADDR           =-4028)
      PARAMETER (VSL_SS_ERROR_METHOD_NOT_SUPPORTED           =-4029)
      PARAMETER (VSL_SS_ERROR_BAD_GROUP_INDC_ADDR            =-4030)
      PARAMETER (VSL_SS_ERROR_NULL_TASK_DESCRIPTOR           =-4031)
      PARAMETER (VSL_SS_ERROR_BAD_OBSERV_ADDR                =-4032)
      PARAMETER (VSL_SS_ERROR_SINGULAR_COV                   =-4033)
      PARAMETER (VSL_SS_ERROR_BAD_POOLED_COV_ADDR            =-4034)
      PARAMETER (VSL_SS_ERROR_BAD_POOLED_MEAN_ADDR           =-4035)
      PARAMETER (VSL_SS_ERROR_BAD_GROUP_COV_ADDR             =-4036)
      PARAMETER (VSL_SS_ERROR_BAD_GROUP_MEAN_ADDR            =-4037)
      PARAMETER (VSL_SS_ERROR_BAD_GROUP_INDC                 =-4038)
      PARAMETER (VSL_SS_ERROR_BAD_OUTLIERS_PARAMS_ADDR       =-4039)
      PARAMETER (VSL_SS_ERROR_BAD_OUTLIERS_PARAMS_N_ADDR     =-4040)
      PARAMETER (VSL_SS_ERROR_BAD_OUTLIERS_WEIGHTS_ADDR      =-4041)
      PARAMETER (VSL_SS_ERROR_BAD_ROBUST_COV_PARAMS_ADDR     =-4042)
      PARAMETER (VSL_SS_ERROR_BAD_ROBUST_COV_PARAMS_N_ADDR   =-4043)
      PARAMETER (VSL_SS_ERROR_BAD_STORAGE_ADDR               =-4044)
      PARAMETER (VSL_SS_ERROR_BAD_PARTIAL_COV_IDX_ADDR       =-4045)
      PARAMETER (VSL_SS_ERROR_BAD_PARTIAL_COV_ADDR           =-4046)
      PARAMETER (VSL_SS_ERROR_BAD_PARTIAL_COR_ADDR           =-4047)
      PARAMETER (VSL_SS_ERROR_BAD_MI_PARAMS_ADDR             =-4048)
      PARAMETER (VSL_SS_ERROR_BAD_MI_PARAMS_N_ADDR           =-4049)
      PARAMETER (VSL_SS_ERROR_BAD_MI_BAD_PARAMS_N            =-4050)
      PARAMETER (VSL_SS_ERROR_BAD_MI_PARAMS                  =-4051)
      PARAMETER (VSL_SS_ERROR_BAD_MI_INIT_ESTIMATES_N_ADDR   =-4052)
      PARAMETER (VSL_SS_ERROR_BAD_MI_INIT_ESTIMATES_ADDR     =-4053)
      PARAMETER (VSL_SS_ERROR_BAD_MI_SIMUL_VALS_ADDR         =-4054)
      PARAMETER (VSL_SS_ERROR_BAD_MI_SIMUL_VALS_N_ADDR       =-4055)
      PARAMETER (VSL_SS_ERROR_BAD_MI_ESTIMATES_N_ADDR        =-4056)
      PARAMETER (VSL_SS_ERROR_BAD_MI_ESTIMATES_ADDR          =-4057)
      PARAMETER (VSL_SS_ERROR_BAD_MI_SIMUL_VALS_N            =-4058)
      PARAMETER (VSL_SS_ERROR_BAD_MI_ESTIMATES_N             =-4059)
      PARAMETER (VSL_SS_ERROR_BAD_MI_OUTPUT_PARAMS           =-4060)
      PARAMETER (VSL_SS_ERROR_BAD_MI_PRIOR_N_ADDR            =-4061)
      PARAMETER (VSL_SS_ERROR_BAD_MI_PRIOR_ADDR              =-4062)
      PARAMETER (VSL_SS_ERROR_BAD_MI_MISSING_VALS_N          =-4063)
      PARAMETER (VSL_SS_ERROR_BAD_STREAM_QUANT_PARAMS_N_ADDR =-4064)
      PARAMETER (VSL_SS_ERROR_BAD_STREAM_QUANT_PARAMS_ADDR   =-4065)
      PARAMETER (VSL_SS_ERROR_BAD_STREAM_QUANT_PARAMS_N      =-4066)
      PARAMETER (VSL_SS_ERROR_BAD_STREAM_QUANT_PARAMS        =-4067)
      PARAMETER (VSL_SS_ERROR_BAD_STREAM_QUANT_ORDER_ADDR    =-4068)
      PARAMETER (VSL_SS_ERROR_BAD_STREAM_QUANT_ORDER         =-4069)
      PARAMETER (VSL_SS_ERROR_BAD_STREAM_QUANT_ADDR          =-4070)
      PARAMETER (VSL_SS_ERROR_BAD_PARAMTR_COR_ADDR           =-4071)
      PARAMETER (VSL_SS_ERROR_BAD_COR                        =-4072)
      PARAMETER (VSL_SS_ERROR_BAD_PARTIAL_COV_IDX            =-4073)

!  Internal errors caused by internal routines of the functions
      INTEGER*4 VSL_SS_ERROR_ROBCOV_INTERN_C1
      INTEGER*4 VSL_SS_ERROR_PARTIALCOV_INTERN_C1
      INTEGER*4 VSL_SS_ERROR_PARTIALCOV_INTERN_C2
      INTEGER*4 VSL_SS_ERROR_MISSINGVALS_INTERN_C1
      INTEGER*4 VSL_SS_ERROR_MISSINGVALS_INTERN_C2
      INTEGER*4 VSL_SS_ERROR_MISSINGVALS_INTERN_C3
      INTEGER*4 VSL_SS_ERROR_MISSINGVALS_INTERN_C4
      INTEGER*4 VSL_SS_ERROR_MISSINGVALS_INTERN_C5
      INTEGER*4 VSL_SS_ERROR_PARAMTRCOR_INTERN_C1
      INTEGER*4 VSL_SS_ERROR_COVRANK_INTERNAL_ERROR_C1
      INTEGER*4 VSL_SS_ERROR_INVCOV_INTERNAL_ERROR_C1
      INTEGER*4 VSL_SS_ERROR_INVCOV_INTERNAL_ERROR_C2

      PARAMETER (VSL_SS_ERROR_ROBCOV_INTERN_C1          =-5000)
      PARAMETER (VSL_SS_ERROR_PARTIALCOV_INTERN_C1      =-5010)
      PARAMETER (VSL_SS_ERROR_PARTIALCOV_INTERN_C2      =-5011)
      PARAMETER (VSL_SS_ERROR_MISSINGVALS_INTERN_C1     =-5021)
      PARAMETER (VSL_SS_ERROR_MISSINGVALS_INTERN_C2     =-5022)
      PARAMETER (VSL_SS_ERROR_MISSINGVALS_INTERN_C3     =-5023)
      PARAMETER (VSL_SS_ERROR_MISSINGVALS_INTERN_C4     =-5024)
      PARAMETER (VSL_SS_ERROR_MISSINGVALS_INTERN_C5     =-5025)
      PARAMETER (VSL_SS_ERROR_PARAMTRCOR_INTERN_C1      =-5030)
      PARAMETER (VSL_SS_ERROR_COVRANK_INTERNAL_ERROR_C1 =-5040)
      PARAMETER (VSL_SS_ERROR_INVCOV_INTERNAL_ERROR_C1  =-5041)
      PARAMETER (VSL_SS_ERROR_INVCOV_INTERNAL_ERROR_C2  =-5042)

!++
!  CONV/CORR RELATED MACRO DEFINITIONS
!--
      INTEGER*4 VSL_CONV_MODE_AUTO
      INTEGER*4 VSL_CORR_MODE_AUTO
      INTEGER*4 VSL_CONV_MODE_DIRECT
      INTEGER*4 VSL_CORR_MODE_DIRECT
      INTEGER*4 VSL_CONV_MODE_FFT
      INTEGER*4 VSL_CORR_MODE_FFT
      INTEGER*4 VSL_CONV_PRECISION_SINGLE
      INTEGER*4 VSL_CORR_PRECISION_SINGLE
      INTEGER*4 VSL_CONV_PRECISION_DOUBLE
      INTEGER*4 VSL_CORR_PRECISION_DOUBLE
      PARAMETER (VSL_CONV_MODE_AUTO        = 0)
      PARAMETER (VSL_CORR_MODE_AUTO        = 0)
      PARAMETER (VSL_CONV_MODE_DIRECT      = 1)
      PARAMETER (VSL_CORR_MODE_DIRECT      = 1)
      PARAMETER (VSL_CONV_MODE_FFT         = 2)
      PARAMETER (VSL_CORR_MODE_FFT         = 2)
      PARAMETER (VSL_CONV_PRECISION_SINGLE = 1)
      PARAMETER (VSL_CORR_PRECISION_SINGLE = 1)
      PARAMETER (VSL_CONV_PRECISION_DOUBLE = 2)
      PARAMETER (VSL_CORR_PRECISION_DOUBLE = 2)


!++
!  BASIC RANDOM NUMBER GENERATOR (BRNG) RELATED MACRO DEFINITIONS
!--


!  MAX NUMBER OF BRNGS CAN BE REGISTERED IN VSL
!  No more than VSL_MAX_REG_BRNGS basic generators can be registered in VSL
!  (including predefined basic generators).
!
!  Change this number to increase/decrease number of BRNGs can be registered.
      INTEGER VSL_MAX_REG_BRNGS
      PARAMETER (VSL_MAX_REG_BRNGS = 512)

!  PREDEFINED BRNG NAMES
      INTEGER VSL_BRNG_SHIFT
      INTEGER VSL_BRNG_INC

      INTEGER VSL_BRNG_MCG31
      INTEGER VSL_BRNG_R250
      INTEGER VSL_BRNG_MRG32K3A
      INTEGER VSL_BRNG_MCG59
      INTEGER VSL_BRNG_WH
      INTEGER VSL_BRNG_SOBOL
      INTEGER VSL_BRNG_NIEDERR
      INTEGER VSL_BRNG_MT19937
      INTEGER VSL_BRNG_MT2203
      INTEGER VSL_BRNG_IABSTRACT
      INTEGER VSL_BRNG_DABSTRACT
      INTEGER VSL_BRNG_SABSTRACT
      INTEGER VSL_BRNG_SFMT19937

      PARAMETER (VSL_BRNG_INC  = Z"00100000")

      PARAMETER (VSL_BRNG_MCG31    =VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_R250     =VSL_BRNG_MCG31    +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_MRG32K3A =VSL_BRNG_R250     +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_MCG59    =VSL_BRNG_MRG32K3A +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_WH       =VSL_BRNG_MCG59    +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_SOBOL    =VSL_BRNG_WH       +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_NIEDERR  =VSL_BRNG_SOBOL    +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_MT19937  =VSL_BRNG_NIEDERR  +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_MT2203   =VSL_BRNG_MT19937  +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_IABSTRACT=VSL_BRNG_MT2203   +VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_DABSTRACT=VSL_BRNG_IABSTRACT+VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_SABSTRACT=VSL_BRNG_DABSTRACT+VSL_BRNG_INC)
      PARAMETER (VSL_BRNG_SFMT19937=VSL_BRNG_SABSTRACT+VSL_BRNG_INC)

!  LEAPFROG METHOD FOR GRAY-CODE BASED QUASI-RANDOM NUMBER BASIC GENERATORS
!  VSL_BRNG_SOBOL and VSL_BRNG_NIEDERR are Gray-code based quasi-random number
!  basic generators. In contrast to pseudorandom number basic generators,
!  quasi-random ones take the dimension as initialization parameter.
!
!  Suppose that quasi-random number generator (QRNG) dimension is S. QRNG
!  sequence is a sequence of S-dimensional vectors:
!
!     x0=(x0[0],x0[1],...,x0[S-1]),x1=(x1[0],x1[1],...,x1[S-1]),...
!
!  VSL treats the output of any basic generator as 1-dimensional, however:
!
!     x0[0],x0[1],...,x0[S-1],x1[0],x1[1],...,x1[S-1],...
!
!  Because of nature of VSL_BRNG_SOBOL and VSL_BRNG_NIEDERR QRNGs,
!  the only S-stride Leapfrog method is supported for them. In other words,
!  user can generate subsequences, which consist of fixed elements of
!  vectors x0,x1,... For example, if 0 element is fixed, the following
!  subsequence is generated:
!
!     x0[1],x1[1],x2[1],...
!
!  To use the s-stride Leapfrog method with given QRNG, user should call
!  vslLeapfrogStream function with parameter k equal to element to be fixed
!  (0<=k<S) and parameter nstreams equal to VSL_QRNG_LEAPFROG_COMPONENTS.
      INTEGER*4 VSL_QRNG_LEAPFROG_COMPONENTS
      PARAMETER (VSL_QRNG_LEAPFROG_COMPONENTS = Z"7FFFFFFF")


!  USER-DEFINED PARAMETERS FOR QUASI-RANDOM NUMBER BASIC GENERATORS
!  VSL_BRNG_SOBOL and VSL_BRNG_NIEDERR are Gray-code based quasi-random
!  number basic generators. Default parameters of the generators
!  support generation of quasi-random number vectors of dimensions
!  S<=40 for SOBOL and S<=318 for NIEDERRITER. The library provides
!  opportunity to register user-defined initial values for the
!  generators and generate quasi-random vectors of desirable dimension.
!  There is also opportunity to register user-defined parameters for
!  default dimensions and obtain another sequence of quasi-random vectors.
!  Service function vslNewStreamEx is used to pass the parameters to
!  the library. Data are packed into array params, parameter of the routine.
!  First element of the array is used for dimension S, second element
!  contains indicator, VSL_USER_QRNG_INITIAL_VALUES, of user-defined
!  parameters for quasi-random number generators.
!  Macros VSL_USER_PRIMITIVE_POLYMS and VSL_USER_INIT_DIRECTION_NUMBERS
!  are used to describe which data are passed to SOBOL QRNG and
!  VSL_USER_IRRED_POLYMS - which data are passed to NIEDERRITER QRNG.
!  For example, to demonstrate that both primitive polynomials and initial
!  direction numbers are passed in SOBOL one should set third element of the
!  array params to  VSL_USER_PRIMITIVE_POLYMS | VSL_USER_DIRECTION_NUMBERS.
!  Macro VSL_QRNG_OVERRIDE_1ST_DIM_INIT is used to override default
!  initialization for the first dimension. Macro VSL_USER_DIRECTION_NUMBERS
!  is used when direction numbers calculated on the user side are passed
!  into the generators. More detailed description of interface for
!  registration of user-defined QRNG initial parameters can be found
!  in VslNotes.pdf.
      INTEGER VSL_USER_QRNG_INITIAL_VALUES
      INTEGER VSL_USER_PRIMITIVE_POLYMS
      INTEGER VSL_USER_INIT_DIRECTION_NUMBERS
      INTEGER VSL_USER_IRRED_POLYMS
      INTEGER VSL_USER_DIRECTION_NUMBERS
      INTEGER VSL_QRNG_OVERRIDE_1ST_DIM_INIT

      PARAMETER (VSL_USER_QRNG_INITIAL_VALUES    = 1)
      PARAMETER (VSL_USER_PRIMITIVE_POLYMS       = 1)
      PARAMETER (VSL_USER_INIT_DIRECTION_NUMBERS = 2)
      PARAMETER (VSL_USER_IRRED_POLYMS           = 1)
      PARAMETER (VSL_USER_DIRECTION_NUMBERS      = 4)
      PARAMETER (VSL_QRNG_OVERRIDE_1ST_DIM_INIT  = 8)

!  INITIALIZATION METHODS FOR USER-DESIGNED BASIC RANDOM NUMBER GENERATORS.
!  Each BRNG must support at least VSL_INIT_METHOD_STANDARD initialization
!  method. In addition, VSL_INIT_METHOD_LEAPFROG and VSL_INIT_METHOD_SKIPAHEAD
!  initialization methods can be supported.
!
!  If VSL_INIT_METHOD_LEAPFROG is not supported then initialization routine
!  must return VSL_ERROR_LEAPFROG_UNSUPPORTED error code.
!
!  If VSL_INIT_METHOD_SKIPAHEAD is not supported then initialization routine
!  must return VSL_ERROR_SKIPAHEAD_UNSUPPORTED error code.
!
!  If there is no error during initialization, the initialization routine must
!  return VSL_ERROR_OK code.
      INTEGER VSL_INIT_METHOD_STANDARD
      INTEGER VSL_INIT_METHOD_LEAPFROG
      INTEGER VSL_INIT_METHOD_SKIPAHEAD
      PARAMETER (VSL_INIT_METHOD_STANDARD  = 0)
      PARAMETER (VSL_INIT_METHOD_LEAPFROG  = 1)
      PARAMETER (VSL_INIT_METHOD_SKIPAHEAD = 2)


!++
!  ACCURACY FLAG FOR DISTRIBUTION GENERATORS
!  This flag defines mode of random number generation.
!  If accuracy mode is set distribution generators will produce
!  numbers lying exactly within definitional domain for all values
!  of distribution parameters. In this case slight performance
!  degradation is expected. By default accuracy mode is switched off
!  admitting random numbers to be out of the definitional domain for
!  specific values of distribution parameters.
!  This macro is used to form names for accuracy versions of
!  distribution number generators
!--

      INTEGER*4 VSL_RNG_METHOD_ACCURACY_FLAG
      PARAMETER (VSL_RNG_METHOD_ACCURACY_FLAG=ISHFT(1,30))

!++
!  TRANSFORMATION METHOD NAMES FOR DISTRIBUTION RANDOM NUMBER GENERATORS
!  VSL interface allows more than one generation method in a distribution
!  transformation subroutine. Following macro definitions are used to
!  specify generation method for given distribution generator.
!
!  Method name macro is constructed as
!
!     VSL_RNG_METHOD_<Distribution>_<Method>
!
!  where
!
!     <Distribution> - probability distribution
!     <Method> - method name
!
!  VSL_RNG_METHOD_<Distribution>_<Method> should be used with
!  vsl<precision>Rng<Distribution> function only, where
!
!     <precision> - s (single) or d (double)
!     <Distribution> - probability distribution
!--

! Uniform
!
! <Method>   <Short Description>
! STD        standard method. Currently there is only one method for this
!            distribution generator
      INTEGER VSL_RNG_METHOD_UNIFORM_STD
      PARAMETER (VSL_RNG_METHOD_UNIFORM_STD = 0)

      INTEGER VSL_RNG_METHOD_UNIFORM_STD_ACCURATE
      PARAMETER (VSL_RNG_METHOD_UNIFORM_STD_ACCURATE=                   &
     & IOR(VSL_RNG_METHOD_UNIFORM_STD, VSL_RNG_METHOD_ACCURACY_FLAG))


! Uniform Bits
!
! <Method>   <Short Description>
! STD        standard method. Currently there is only one method for this
!            distribution generator
      INTEGER VSL_RNG_METHOD_UNIFORMBITS_STD
      PARAMETER (VSL_RNG_METHOD_UNIFORMBITS_STD = 0)

! Gaussian
!
! <Method>   <Short Description>
! BOXMULLER  generates normally distributed random number x thru the pair of
!            uniformly distributed numbers u1 and u2 according to the formula:
!
!               x=sqrt(-ln(u1))*sin(2*Pi*u2)
!
! BOXMULLER2 generates pair of normally distributed random numbers x1 and x2
!            thru the pair of uniformly dustributed numbers u1 and u2
!            according to the formula
!
!               x1=sqrt(-ln(u1))*sin(2*Pi*u2)
!               x2=sqrt(-ln(u1))*cos(2*Pi*u2)
!
!            NOTE: implementation correctly works with odd vector lengths
!
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_GAUSSIAN_BOXMULLER
      INTEGER VSL_RNG_METHOD_GAUSSIAN_BOXMULLER2
      INTEGER VSL_RNG_METHOD_GAUSSIAN_ICDF
      PARAMETER (VSL_RNG_METHOD_GAUSSIAN_BOXMULLER  = 0)
      PARAMETER (VSL_RNG_METHOD_GAUSSIAN_BOXMULLER2 = 1)
      PARAMETER (VSL_RNG_METHOD_GAUSSIAN_ICDF       = 2)

! GaussianMV - multivariate (correlated) normal
! Multivariate (correlated) normal random number generator is based on
! uncorrelated Gaussian random number generator (see vslsRngGaussian and
! vsldRngGaussian functions):
!
! <Method>   <Short Description>
! BOXMULLER  generates normally distributed random number x thru the pair of
!            uniformly distributed numbers u1 and u2 according to the formula:
!
!               x=sqrt(-ln(u1))*sin(2*Pi*u2)
!
! BOXMULLER2 generates pair of normally distributed random numbers x1 and x2
!            thru the pair of uniformly dustributed numbers u1 and u2
!            according to the formula
!
!               x1=sqrt(-ln(u1))*sin(2*Pi*u2)
!               x2=sqrt(-ln(u1))*cos(2*Pi*u2)
!
!            NOTE: implementation correctly works with odd vector lengths
!
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_GAUSSIANMV_BOXMULLER
      INTEGER VSL_RNG_METHOD_GAUSSIANMV_BOXMULLER2
      INTEGER VSL_RNG_METHOD_GAUSSIANMV_ICDF
      PARAMETER (VSL_RNG_METHOD_GAUSSIANMV_BOXMULLER  = 0)
      PARAMETER (VSL_RNG_METHOD_GAUSSIANMV_BOXMULLER2 = 1)
      PARAMETER (VSL_RNG_METHOD_GAUSSIANMV_ICDF       = 2)

! Exponential
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_EXPONENTIAL_ICDF
      PARAMETER (VSL_RNG_METHOD_EXPONENTIAL_ICDF = 0)

      INTEGER VSL_RNG_METHOD_EXPONENTIAL_ICDF_ACCURATE
      PARAMETER (VSL_RNG_METHOD_EXPONENTIAL_ICDF_ACCURATE=              &
     &IOR(VSL_RNG_METHOD_EXPONENTIAL_ICDF,VSL_RNG_METHOD_ACCURACY_FLAG))

! Laplace
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
!
! ICDF - inverse cumulative distribution function method:
!
!           x=+/-ln(u) with probability 1/2,
!
!        where
!
!           x - random number with Laplace distribution,
!           u - uniformly distributed random number
      INTEGER VSL_RNG_METHOD_LAPLACE_ICDF
      PARAMETER (VSL_RNG_METHOD_LAPLACE_ICDF = 0)

! Weibull
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_WEIBULL_ICDF
      PARAMETER (VSL_RNG_METHOD_WEIBULL_ICDF = 0)

      INTEGER VSL_RNG_METHOD_WEIBULL_ICDF_ACCURATE
      PARAMETER (VSL_RNG_METHOD_WEIBULL_ICDF_ACCURATE=                  &
     & IOR(VSL_RNG_METHOD_WEIBULL_ICDF, VSL_RNG_METHOD_ACCURACY_FLAG))



! Cauchy
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_CAUCHY_ICDF
      PARAMETER (VSL_RNG_METHOD_CAUCHY_ICDF = 0)

! Rayleigh
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_RAYLEIGH_ICDF
      PARAMETER (VSL_RNG_METHOD_RAYLEIGH_ICDF = 0)

      INTEGER VSL_RNG_METHOD_RAYLEIGH_ICDF_ACCURATE
      PARAMETER (VSL_RNG_METHOD_RAYLEIGH_ICDF_ACCURATE=                 &
     & IOR(VSL_RNG_METHOD_RAYLEIGH_ICDF, VSL_RNG_METHOD_ACCURACY_FLAG))


! Lognormal
!
! <Method>   <Short Description>
! BOXMULLER2      Box-Muller 2 algorithm based method
      INTEGER VSL_RNG_METHOD_LOGNORMAL_BOXMULLER2
      INTEGER VSL_RNG_METHOD_LOGNORMAL_ICDF
      PARAMETER (VSL_RNG_METHOD_LOGNORMAL_BOXMULLER2 = 0)
      PARAMETER (VSL_RNG_METHOD_LOGNORMAL_ICDF = 0)

      INTEGER VSL_RNG_METHOD_LOGNORMAL_BOXMULLER2_ACCURATE
      INTEGER VSL_RNG_METHOD_LOGNORMAL_ICDF_ACCURATE
      PARAMETER (VSL_RNG_METHOD_LOGNORMAL_BOXMULLER2_ACCURATE=          &
     & IOR(VSL_RNG_METHOD_LOGNORMAL_BOXMULLER2,                         &
     &     VSL_RNG_METHOD_ACCURACY_FLAG))
      PARAMETER (VSL_RNG_METHOD_LOGNORMAL_ICDF_ACCURATE=                &
     & IOR(VSL_RNG_METHOD_LOGNORMAL_ICDF, VSL_RNG_METHOD_ACCURACY_FLAG))


! Gumbel
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_GUMBEL_ICDF
      PARAMETER (VSL_RNG_METHOD_GUMBEL_ICDF = 0)

! Gamma
!
! <Method>     <Short Description>
! GNORM        nonlinear transformation of gaussian numbers
! alpha>1,     based on acceptance/rejection method with
!              squeezes
!
! alpha>=0.6,  rejection from the Weibull distribution
! alpha<1
!
! alpha<0.6,   transformation of exponential power distribution
!              (EPD), EPD random numbers are generated using
!              by means of acceptance/rejection technique
      INTEGER VSL_RNG_METHOD_GAMMA_GNORM
      PARAMETER (VSL_RNG_METHOD_GAMMA_GNORM = 0)

      INTEGER VSL_RNG_METHOD_GAMMA_GNORM_ACCURATE
      PARAMETER (VSL_RNG_METHOD_GAMMA_GNORM_ACCURATE=                   &
     & IOR(VSL_RNG_METHOD_GAMMA_GNORM, VSL_RNG_METHOD_ACCURACY_FLAG))


! Beta
!
! <Method>     <Short Description>
! CJA - stands for first letters of Cheng, Johnk, and Atkinson
! Cheng      - generation of beta random numbers of the second kind
! min(p,q)>1   based on acceptance/rejection technique and its
!              transformation to beta random numbers of the first kind;
!
! Johnk,     - if q + K*p^2+C<=0, K=0.852..., C=-0.956...
! Atkinson,    algorithm of Johnk: beta distributed random number
! max(p,q)<1   is generated as u1^(1/p) / (u1^(1/p)+u2^(1/q)),
!              if u1^(1/p)+u2^(1/q)<=1;
!              otherwise switching algorithm of Atkinson:
!              interval (0,1) is divided into two domains (0,t) and (t,1),
!              on each interval acceptance/rejection technique with
!              convenient majorizing function is used;
!
! Atkinson   - switching algorithm of Atkinson is used
! min(p,q)<1   (with another point t, see short description above);
! max(p,q)>1
!
! ICDF       - inverse cumulative distribution function method according
!              to formulas x=1-u^(1/q) for p = 1, and x = u^(1/p) for q=1,
!              where x is beta distributed random number,
!              u - uniformly distributed random number.
!              for p=q=1 beta distribution reduces to uniform distribution.

      INTEGER VSL_RNG_METHOD_BETA_CJA
      PARAMETER (VSL_RNG_METHOD_BETA_CJA = 0)

      INTEGER VSL_RNG_METHOD_BETA_CJA_ACCURATE
      PARAMETER (VSL_RNG_METHOD_BETA_CJA_ACCURATE=                      &
     & IOR(VSL_RNG_METHOD_BETA_CJA, VSL_RNG_METHOD_ACCURACY_FLAG))



! Bernoulli
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_BERNOULLI_ICDF
      PARAMETER (VSL_RNG_METHOD_BERNOULLI_ICDF = 0)

! Geometric
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_RNG_METHOD_GEOMETRIC_ICDF
      PARAMETER (VSL_RNG_METHOD_GEOMETRIC_ICDF = 0)

! Binomial
!
! <Method>   <Short Description>
! BTPE       for ntrial*min(p,1-p)>30 acceptance/rejection method with
!            decomposition onto 4 regions:
!
!               * 2 parallelograms;
!               * triangle;
!               * left exponential tail;
!               * right exponential tail.
!
!            othewise table lookup method is used
      INTEGER VSL_RNG_METHOD_BINOMIAL_BTPE
      PARAMETER (VSL_RNG_METHOD_BINOMIAL_BTPE = 0)

! Hypergeometric
!
! <Method>   <Short Description>
! H2PE       if mode of distribution is large, acceptance/rejection method is
!            used with decomposition onto 3 regions:
!
!               * rectangular;
!               * left exponential tail;
!               * right exponential tail.
!
!            othewise table lookup method is used
      INTEGER VSL_RNG_METHOD_HYPERGEOMETRIC_H2PE
      PARAMETER (VSL_RNG_METHOD_HYPERGEOMETRIC_H2PE = 0)

! Poisson
!
! <Method>   <Short Description>
! PTPE       if lambda>=27, acceptance/rejection method is used with
!            decomposition onto 4 regions:
!
!               * 2 parallelograms;
!               * triangle;
!               * left exponential tail;
!               * right exponential tail.
!
!            othewise table lookup method is used
!
! POISNORM   for lambda>=1 method is based on Poisson inverse CDF
!            approximation by Gaussian inverse CDF; for lambda<1
!            table lookup method is used.
      INTEGER VSL_RNG_METHOD_POISSON_PTPE
      INTEGER VSL_RNG_METHOD_POISSON_POISNORM
      PARAMETER (VSL_RNG_METHOD_POISSON_PTPE     = 0)
      PARAMETER (VSL_RNG_METHOD_POISSON_POISNORM = 1)

! Poisson
!
! <Method>   <Short Description>
! POISNORM   for lambda>=1 method is based on Poisson inverse CDF
!            approximation by Gaussian inverse CDF; for lambda<1
!            ICDF method is used.
      INTEGER VSL_RNG_METHOD_POISSONV_POISNORM
      PARAMETER (VSL_RNG_METHOD_POISSONV_POISNORM = 0)

! Negbinomial
!
! <Method>   <Short Description>
! NBAR       if (a-1)*(1-p)/p>=100, acceptance/rejection method is used with
!            decomposition onto 5 regions:
!
!               * rectangular;
!               * 2 trapezoid;
!               * left exponential tail;
!               * right exponential tail.
!
!            othewise table lookup method is used.
      INTEGER VSL_RNG_METHOD_NEGBINOMIAL_NBAR
      PARAMETER (VSL_RNG_METHOD_NEGBINOMIAL_NBAR = 0)

!++
! BEGINNING OF DEPRECATED SECTION
!--
!++
!  ACCURACY FLAG FOR DISTRIBUTION GENERATORS
!  This flag defines mode of random number generation.
!  If accuracy mode is set distribution generators will produce
!  numbers lying exactly within definitional domain for all values
!  of distribution parameters. In this case slight performance
!  degradation is expected. By default accuracy mode is switched off
!  admitting random numbers to be out of the definitional domain for
!  specific values of distribution parameters.
!  This macro is used to form names for accuracy versions of
!  distribution number generators
!--
      INTEGER*4 VSL_METHOD_ACCURACY_FLAG
      PARAMETER (VSL_METHOD_ACCURACY_FLAG = Z"40000000")

!++
!  TRANSFORMATION METHOD NAMES FOR DISTRIBUTION RANDOM NUMBER GENERATORS
!  VSL interface allows more than one generation method in a distribution
!  transformation subroutine. Following macro definitions are used to
!  specify generation method for given distribution generator.
!
!  Method name macro is constructed as
!
!     VSL_METHOD_<Precision><Distribution>_<Method>
!
!  where
!
!     <Precision> - S (single precision) or D (double precision)
!     <Distribution> - probability distribution
!     <Method> - method name
!
!  VSL_METHOD_<Precision><Distribution>_<Method> should be used with
!  vsl<precision>Rng<Distribution> function only, where
!
!     <precision> - s (single) or d (double)
!     <Distribution> - probability distribution
!--

! Uniform
!
! <Method>   <Short Description>
! STD        standard method. Currently there is only one method for this
!            distribution generator
      INTEGER VSL_METHOD_SUNIFORM_STD
      INTEGER VSL_METHOD_DUNIFORM_STD
      INTEGER VSL_METHOD_IUNIFORM_STD
      PARAMETER (VSL_METHOD_SUNIFORM_STD = 0)
      PARAMETER (VSL_METHOD_DUNIFORM_STD = 0)
      PARAMETER (VSL_METHOD_IUNIFORM_STD = 0)

      INTEGER VSL_METHOD_SUNIFORM_STD_ACCURATE
      INTEGER VSL_METHOD_DUNIFORM_STD_ACCURATE
      PARAMETER (VSL_METHOD_SUNIFORM_STD_ACCURATE = Z"40000000")
      PARAMETER (VSL_METHOD_DUNIFORM_STD_ACCURATE = Z"40000000")


! Uniform Bits
!
! <Method>   <Short Description>
! STD        standard method. Currently there is only one method for this
!            distribution generator
      INTEGER VSL_METHOD_IUNIFORMBITS_STD
      PARAMETER (VSL_METHOD_IUNIFORMBITS_STD = 0)

! Gaussian
!
! <Method>   <Short Description>
! BOXMULLER  generates normally distributed random number x thru the pair of
!            uniformly distributed numbers u1 and u2 according to the formula:
!
!               x=sqrt(-ln(u1))*sin(2*Pi*u2)
!
! BOXMULLER2 generates pair of normally distributed random numbers x1 and x2
!            thru the pair of uniformly dustributed numbers u1 and u2
!            according to the formula
!
!               x1=sqrt(-ln(u1))*sin(2*Pi*u2)
!               x2=sqrt(-ln(u1))*cos(2*Pi*u2)
!
!            NOTE: implementation correctly works with odd vector lengths
!
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_SGAUSSIAN_BOXMULLER
      INTEGER VSL_METHOD_SGAUSSIAN_BOXMULLER2
      INTEGER VSL_METHOD_SGAUSSIAN_ICDF
      INTEGER VSL_METHOD_DGAUSSIAN_BOXMULLER
      INTEGER VSL_METHOD_DGAUSSIAN_BOXMULLER2
      INTEGER VSL_METHOD_DGAUSSIAN_ICDF
      PARAMETER (VSL_METHOD_SGAUSSIAN_BOXMULLER  = 0)
      PARAMETER (VSL_METHOD_SGAUSSIAN_BOXMULLER2 = 1)
      PARAMETER (VSL_METHOD_SGAUSSIAN_ICDF       = 2)
      PARAMETER (VSL_METHOD_DGAUSSIAN_BOXMULLER  = 0)
      PARAMETER (VSL_METHOD_DGAUSSIAN_BOXMULLER2 = 1)
      PARAMETER (VSL_METHOD_DGAUSSIAN_ICDF       = 2)

! GaussianMV - multivariate (correlated) normal
! Multivariate (correlated) normal random number generator is based on
! uncorrelated Gaussian random number generator (see vslsRngGaussian and
! vsldRngGaussian functions):
!
! <Method>   <Short Description>
! BOXMULLER  generates normally distributed random number x thru the pair of
!            uniformly distributed numbers u1 and u2 according to the formula:
!
!               x=sqrt(-ln(u1))*sin(2*Pi*u2)
!
! BOXMULLER2 generates pair of normally distributed random numbers x1 and x2
!            thru the pair of uniformly dustributed numbers u1 and u2
!            according to the formula
!
!               x1=sqrt(-ln(u1))*sin(2*Pi*u2)
!               x2=sqrt(-ln(u1))*cos(2*Pi*u2)
!
!            NOTE: implementation correctly works with odd vector lengths
!
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_SGAUSSIANMV_BOXMULLER
      INTEGER VSL_METHOD_SGAUSSIANMV_BOXMULLER2
      INTEGER VSL_METHOD_SGAUSSIANMV_ICDF
      INTEGER VSL_METHOD_DGAUSSIANMV_BOXMULLER
      INTEGER VSL_METHOD_DGAUSSIANMV_BOXMULLER2
      INTEGER VSL_METHOD_DGAUSSIANMV_ICDF
      PARAMETER (VSL_METHOD_SGAUSSIANMV_BOXMULLER  = 0)
      PARAMETER (VSL_METHOD_SGAUSSIANMV_BOXMULLER2 = 1)
      PARAMETER (VSL_METHOD_SGAUSSIANMV_ICDF       = 2)
      PARAMETER (VSL_METHOD_DGAUSSIANMV_BOXMULLER  = 0)
      PARAMETER (VSL_METHOD_DGAUSSIANMV_BOXMULLER2 = 1)
      PARAMETER (VSL_METHOD_DGAUSSIANMV_ICDF       = 2)

! Exponential
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_SEXPONENTIAL_ICDF
      INTEGER VSL_METHOD_DEXPONENTIAL_ICDF
      PARAMETER (VSL_METHOD_SEXPONENTIAL_ICDF = 0)
      PARAMETER (VSL_METHOD_DEXPONENTIAL_ICDF = 0)

      INTEGER VSL_METHOD_SEXPONENTIAL_ICDF_ACCURATE
      INTEGER VSL_METHOD_DEXPONENTIAL_ICDF_ACCURATE
      PARAMETER (VSL_METHOD_SEXPONENTIAL_ICDF_ACCURATE = Z"40000000")
      PARAMETER (VSL_METHOD_DEXPONENTIAL_ICDF_ACCURATE = Z"40000000")

! Laplace
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
!
! ICDF - inverse cumulative distribution function method:
!
!           x=+/-ln(u) with probability 1/2,
!
!        where
!
!           x - random number with Laplace distribution,
!           u - uniformly distributed random number
      INTEGER VSL_METHOD_SLAPLACE_ICDF
      INTEGER VSL_METHOD_DLAPLACE_ICDF
      PARAMETER (VSL_METHOD_SLAPLACE_ICDF = 0)
      PARAMETER (VSL_METHOD_DLAPLACE_ICDF = 0)

! Weibull
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_SWEIBULL_ICDF
      INTEGER VSL_METHOD_DWEIBULL_ICDF
      PARAMETER (VSL_METHOD_SWEIBULL_ICDF = 0)
      PARAMETER (VSL_METHOD_DWEIBULL_ICDF = 0)

      INTEGER VSL_METHOD_SWEIBULL_ICDF_ACCURATE
      INTEGER VSL_METHOD_DWEIBULL_ICDF_ACCURATE
      PARAMETER (VSL_METHOD_SWEIBULL_ICDF_ACCURATE = Z"40000000")
      PARAMETER (VSL_METHOD_DWEIBULL_ICDF_ACCURATE = Z"40000000")



! Cauchy
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_SCAUCHY_ICDF
      INTEGER VSL_METHOD_DCAUCHY_ICDF
      PARAMETER (VSL_METHOD_SCAUCHY_ICDF = 0)
      PARAMETER (VSL_METHOD_DCAUCHY_ICDF = 0)

! Rayleigh
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_SRAYLEIGH_ICDF
      INTEGER VSL_METHOD_DRAYLEIGH_ICDF
      PARAMETER (VSL_METHOD_SRAYLEIGH_ICDF = 0)
      PARAMETER (VSL_METHOD_DRAYLEIGH_ICDF = 0)

      INTEGER VSL_METHOD_SRAYLEIGH_ICDF_ACCURATE
      INTEGER VSL_METHOD_DRAYLEIGH_ICDF_ACCURATE
      PARAMETER (VSL_METHOD_SRAYLEIGH_ICDF_ACCURATE = Z"40000000")
      PARAMETER (VSL_METHOD_DRAYLEIGH_ICDF_ACCURATE = Z"40000000")


! Lognormal
!
! <Method>   <Short Description>
! BOXMULLER2      Box-Muller 2 algorithm based method
      INTEGER VSL_METHOD_SLOGNORMAL_BOXMULLER2
      INTEGER VSL_METHOD_DLOGNORMAL_BOXMULLER2
      INTEGER VSL_METHOD_SLOGNORMAL_ICDF
      INTEGER VSL_METHOD_DLOGNORMAL_ICDF
      PARAMETER (VSL_METHOD_SLOGNORMAL_BOXMULLER2 = 0)
      PARAMETER (VSL_METHOD_DLOGNORMAL_BOXMULLER2 = 0)
      PARAMETER (VSL_METHOD_SLOGNORMAL_ICDF = 0)
      PARAMETER (VSL_METHOD_DLOGNORMAL_ICDF = 0)

      INTEGER VSL_METHOD_SLOGNORMAL_BOXMULLER2_ACCURATE
      INTEGER VSL_METHOD_DLOGNORMAL_BOXMULLER2_ACCURATE
      INTEGER VSL_METHOD_SLOGNORMAL_ICDF_ACCURATE
      INTEGER VSL_METHOD_DLOGNORMAL_ICDF_ACCURATE
      PARAMETER (VSL_METHOD_SLOGNORMAL_BOXMULLER2_ACCURATE=Z"40000000")
      PARAMETER (VSL_METHOD_DLOGNORMAL_BOXMULLER2_ACCURATE=Z"40000000")
      PARAMETER (VSL_METHOD_SLOGNORMAL_ICDF_ACCURATE = Z"40000000")
      PARAMETER (VSL_METHOD_DLOGNORMAL_ICDF_ACCURATE = Z"40000000")


! Gumbel
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_SGUMBEL_ICDF
      INTEGER VSL_METHOD_DGUMBEL_ICDF
      PARAMETER (VSL_METHOD_SGUMBEL_ICDF = 0)
      PARAMETER (VSL_METHOD_DGUMBEL_ICDF = 0)

! Gamma
!
! <Method>     <Short Description>
! GNORM        nonlinear transformation of gaussian numbers
! alpha>1,     based on acceptance/rejection method with
!              squeezes
!
! alpha>=0.6,  rejection from the Weibull distribution
! alpha<1
!
! alpha<0.6,   transformation of exponential power distribution
!              (EPD), EPD random numbers are generated using
!              by means of acceptance/rejection technique
      INTEGER VSL_METHOD_SGAMMA_GNORM
      INTEGER VSL_METHOD_DGAMMA_GNORM
      PARAMETER (VSL_METHOD_SGAMMA_GNORM = 0)
      PARAMETER (VSL_METHOD_DGAMMA_GNORM = 0)

      INTEGER VSL_METHOD_SGAMMA_GNORM_ACCURATE
      INTEGER VSL_METHOD_DGAMMA_GNORM_ACCURATE
      PARAMETER (VSL_METHOD_SGAMMA_GNORM_ACCURATE = Z"40000000")
      PARAMETER (VSL_METHOD_DGAMMA_GNORM_ACCURATE = Z"40000000")


! Beta
!
! <Method>     <Short Description>
! CJA - stands for first letters of Cheng, Johnk, and Atkinson
! Cheng      - generation of beta random numbers of the second kind
! min(p,q)>1   based on acceptance/rejection technique and its
!              transformation to beta random numbers of the first kind;
!
! Johnk,     - if q + K*p^2+C<=0, K=0.852..., C=-0.956...
! Atkinson,    algorithm of Johnk: beta distributed random number
! max(p,q)<1   is generated as u1^(1/p) / (u1^(1/p)+u2^(1/q)),
!              if u1^(1/p)+u2^(1/q)<=1;
!              otherwise switching algorithm of Atkinson:
!              interval (0,1) is divided into two domains (0,t) and (t,1),
!              on each interval acceptance/rejection technique with
!              convenient majorizing function is used;
!
! Atkinson   - switching algorithm of Atkinson is used
! min(p,q)<1   (with another point t, see short description above);
! max(p,q)>1
!
! ICDF       - inverse cumulative distribution function method according
!              to formulas x=1-u^(1/q) for p = 1, and x = u^(1/p) for q=1,
!              where x is beta distributed random number,
!              u - uniformly distributed random number.
!              for p=q=1 beta distribution reduces to uniform distribution.

      INTEGER VSL_METHOD_SBETA_CJA
      INTEGER VSL_METHOD_DBETA_CJA
      PARAMETER (VSL_METHOD_SBETA_CJA = 0)
      PARAMETER (VSL_METHOD_DBETA_CJA = 0)

      INTEGER VSL_METHOD_SBETA_CJA_ACCURATE
      INTEGER VSL_METHOD_DBETA_CJA_ACCURATE
      PARAMETER (VSL_METHOD_SBETA_CJA_ACCURATE = Z"40000000")
      PARAMETER (VSL_METHOD_DBETA_CJA_ACCURATE = Z"40000000")



! Bernoulli
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_IBERNOULLI_ICDF
      PARAMETER (VSL_METHOD_IBERNOULLI_ICDF = 0)

! Geometric
!
! <Method>   <Short Description>
! ICDF       inverse cumulative distribution function method
      INTEGER VSL_METHOD_IGEOMETRIC_ICDF
      PARAMETER (VSL_METHOD_IGEOMETRIC_ICDF = 0)

! Binomial
!
! <Method>   <Short Description>
! BTPE       for ntrial*min(p,1-p)>30 acceptance/rejection method with
!            decomposition onto 4 regions:
!
!               * 2 parallelograms;
!               * triangle;
!               * left exponential tail;
!               * right exponential tail.
!
!            othewise table lookup method is used
      INTEGER VSL_METHOD_IBINOMIAL_BTPE
      PARAMETER (VSL_METHOD_IBINOMIAL_BTPE = 0)

! Hypergeometric
!
! <Method>   <Short Description>
! H2PE       if mode of distribution is large, acceptance/rejection method is
!            used with decomposition onto 3 regions:
!
!               * rectangular;
!               * left exponential tail;
!               * right exponential tail.
!
!            othewise table lookup method is used
      INTEGER VSL_METHOD_IHYPERGEOMETRIC_H2PE
      PARAMETER (VSL_METHOD_IHYPERGEOMETRIC_H2PE = 0)

! Poisson
!
! <Method>   <Short Description>
! PTPE       if lambda>=27, acceptance/rejection method is used with
!            decomposition onto 4 regions:
!
!               * 2 parallelograms;
!               * triangle;
!               * left exponential tail;
!               * right exponential tail.
!
!            othewise table lookup method is used
!
! POISNORM   for lambda>=1 method is based on Poisson inverse CDF
!            approximation by Gaussian inverse CDF; for lambda<1
!            table lookup method is used.
      INTEGER VSL_METHOD_IPOISSON_PTPE
      INTEGER VSL_METHOD_IPOISSON_POISNORM
      PARAMETER (VSL_METHOD_IPOISSON_PTPE     = 0)
      PARAMETER (VSL_METHOD_IPOISSON_POISNORM = 1)

! Poisson
!
! <Method>   <Short Description>
! POISNORM   for lambda>=1 method is based on Poisson inverse CDF
!            approximation by Gaussian inverse CDF; for lambda<1
!            ICDF method is used.
      INTEGER VSL_METHOD_IPOISSONV_POISNORM
      PARAMETER (VSL_METHOD_IPOISSONV_POISNORM = 0)

! Negbinomial
!
! <Method>   <Short Description>
! NBAR       if (a-1)*(1-p)/p>=100, acceptance/rejection method is used with
!            decomposition onto 5 regions:
!
!               * rectangular;
!               * 2 trapezoid;
!               * left exponential tail;
!               * right exponential tail.
!
!            othewise table lookup method is used.
      INTEGER VSL_METHOD_INEGBINOMIAL_NBAR
      PARAMETER (VSL_METHOD_INEGBINOMIAL_NBAR = 0)

!++
! END OF DEPRECATED SECTION
!--

!++
!  MATRIX STORAGE SCHEMES
!--

! Some multivariate random number generators, e.g. GaussianMV, operate
! with matrix parameters. To optimize matrix parameters usage VSL offers
! following matrix storage schemes. (See VSL documentation for more details).
!
! FULL     - whole matrix is stored
! PACKED   - lower/higher triangular matrix is packed in 1-dimensional array
! DIAGONAL - diagonal elements are packed in 1-dimensional array
      INTEGER VSL_MATRIX_STORAGE_FULL
      INTEGER VSL_MATRIX_STORAGE_PACKED
      INTEGER VSL_MATRIX_STORAGE_DIAGONAL
      PARAMETER (VSL_MATRIX_STORAGE_FULL     = 0)
      PARAMETER (VSL_MATRIX_STORAGE_PACKED   = 1)
      PARAMETER (VSL_MATRIX_STORAGE_DIAGONAL = 2)


!++
!  SUMMARY STATISTICS (SS) RELATED MACRO DEFINITIONS
!--


!++
!  MATRIX STORAGE SCHEMES
!--

!
! SS routines work with matrix parameters, e.g. matrix of observations,
! variance-covariance matrix. To optimize work with matrices the library
! provides the following storage matrix schemes.
!
!++
! Matrix of observations:
! ROWS    - observations of the random vector are stored in raws, that
!           is, i-th row of the matrix of observations contains values
!           of i-th component of the random vector
! COLS    - observations of the random vector are stored in columns that
!           is, i-th column of the matrix of observations contains values
!           of i-th component of the random vector
!--
      INTEGER VSL_SS_MATRIX_STORAGE_ROWS
      INTEGER VSL_SS_MATRIX_STORAGE_COLS
      PARAMETER (VSL_SS_MATRIX_STORAGE_ROWS    = Z"00010000")
      PARAMETER (VSL_SS_MATRIX_STORAGE_COLS    = Z"00020000")


!++
! Variance-covariance/correlation matrix:
! FULL     - whole matrix is stored
! L_PACKED - lower triangular matrix is stored as 1-dimensional array
! U_PACKED - upper triangular matrix is stored as 1-dimensional array
!--
      INTEGER VSL_SS_MATRIX_STORAGE_FULL
      INTEGER VSL_SS_MATRIX_STORAGE_L_PACKED
      INTEGER VSL_SS_MATRIX_STORAGE_U_PACKED
      PARAMETER (VSL_SS_MATRIX_STORAGE_FULL     = Z"00000000")
      PARAMETER (VSL_SS_MATRIX_STORAGE_L_PACKED = Z"00000001")
      PARAMETER (VSL_SS_MATRIX_STORAGE_U_PACKED = Z"00000002")


!++
!  SUMMARY STATISTICS LIBRARY METHODS
!--

! SS routines provide computation of basic statistical estimates
! (central/raw moments up to 4th order, variance-covariance,
!  minimum, maximum, skewness/kurtosis) using the following methods
!  - FAST  - estimates are computed for prices of one or two passes of the
!            observations using highly optimized MKL routines
!  - 1PASS - estimate is computed for price of one pass of the observations
      INTEGER VSL_SS_METHOD_FAST
      INTEGER VSL_SS_METHOD_1PASS
      PARAMETER (VSL_SS_METHOD_FAST  = Z"00000001")
      PARAMETER (VSL_SS_METHOD_1PASS = Z"00000002")


! SS provides routine for parametrization of correlation matrix using
! SPECTRAL DECOMPOSITION (SD) method
      INTEGER VSL_SS_METHOD_SD
      PARAMETER (VSL_SS_METHOD_SD    = Z"00000004")

! SS routine for robust estimation of variance-covariance matrix
! and mean supports Rocke algorithm, TBS-estimator
      INTEGER VSL_SS_METHOD_TBS
      PARAMETER (VSL_SS_METHOD_TBS  = Z"00000008")

!  SS routine for estimation of missing values
!  supports Multiple Imputation (MI) method
      INTEGER VSL_SS_METHOD_MI
      PARAMETER (VSL_SS_METHOD_MI   = Z"00000010")


! SS provides routine for detection of outliers, BACON method
      INTEGER VSL_SS_METHOD_BACON
      PARAMETER (VSL_SS_METHOD_BACON= Z"00000020")


! SS supports routine for estimation of quantiles for streaming data
! using the following methods:
! - ZW      - intermediate estimates of quantiles during processing
!             the next block are computed
! - ZW      - intermediate estimates of quantiles during processing
!             the next block are not computed
      INTEGER VSL_SS_METHOD_SQUANTS_ZW
      INTEGER VSL_SS_METHOD_SQUANTS_ZW_FAST
      PARAMETER (VSL_SS_METHOD_SQUANTS_ZW      = Z"00000040")
      PARAMETER (VSL_SS_METHOD_SQUANTS_ZW_FAST = Z"00000080")


! Input of BACON algorithm is set of 3 parameters:
! - Initialization method of the algorithm
! - Parameter alfa such that 1-alfa is percentile of Chi2 distribution
! - Stopping criterion

! Number of BACON algorithm parameters
      INTEGER VSL_SS_BACON_PARAMS_N
      PARAMETER (VSL_SS_BACON_PARAMS_N       = 3)


! SS implementation of BACON algorithm supports two initialization methods:
! - Mahalanobis distance based method
! - Median based method
      INTEGER*4 VSL_SS_METHOD_BACON_MAHALANOBIS_INIT
      INTEGER*4 VSL_SS_METHOD_BACON_MEDIAN_INIT
      PARAMETER (VSL_SS_METHOD_BACON_MAHALANOBIS_INIT = Z"00000001")
      PARAMETER (VSL_SS_METHOD_BACON_MEDIAN_INIT      = Z"00000002")


! Input of TBS algorithm is set of 4 parameters:
! - Breakdown point
! - Asymptotic rejection probability
! - Stopping criterion
! - Maximum number of iterations

! Number of TBS algorithm parameters
      INTEGER VSL_SS_TBS_PARAMS_N
      PARAMETER (VSL_SS_TBS_PARAMS_N         = 4)


! Input of MI algorithm is set of 5 parameters:
! - Maximal number of iterations for EM algorithm
! - Maximal number of iterations for DA algorithm
! - Stopping criterion
! - Number of sets to impute
! - Total number of missing values in dataset

! Number of MI algorithm parameters
      INTEGER VSL_SS_MI_PARAMS_SIZE
      PARAMETER (VSL_SS_MI_PARAMS_SIZE       = 5)


! SS MI algorithm expects that missing values are
! marked with NANs
      REAL(KIND=8) VSL_SS_DNAN
      REAL*4 VSL_SS_SNAN
       PARAMETER (VSL_SS_DNAN = Z"FFF8000000000000")
       PARAMETER (VSL_SS_SNAN = Z"FFC00000")


! Input of ZW algorithm is 1 parameter:
! - accuracy of quantile estimation

! Number of ZW algorithm parameters
      INTEGER VSL_SS_SQUANTS_ZW_PARAMS_N
      PARAMETER (VSL_SS_SQUANTS_ZW_PARAMS_N = 1)



!++
!  MACROS USED SS EDIT AND COMPUTE ROUTINES
!--

! SS EditTask routine is way to edit input and output parameters of the task,
! e.g., pointers to arrays which hold observations, weights of observations,
! arrays of mean estimates or covariance estimates.
! Macros below define parameters available for modification 
      INTEGER VSL_SS_ED_DIMEN
      INTEGER VSL_SS_ED_OBSERV_N
      INTEGER VSL_SS_ED_OBSERV
      INTEGER VSL_SS_ED_OBSERV_STORAGE
      INTEGER VSL_SS_ED_INDC
      INTEGER VSL_SS_ED_WEIGHTS
      INTEGER VSL_SS_ED_MEAN
      INTEGER VSL_SS_ED_2R_MOM
      INTEGER VSL_SS_ED_3R_MOM
      INTEGER VSL_SS_ED_4R_MOM
      INTEGER VSL_SS_ED_2C_MOM
      INTEGER VSL_SS_ED_3C_MOM
      INTEGER VSL_SS_ED_4C_MOM
      INTEGER VSL_SS_ED_KURTOSIS
      INTEGER VSL_SS_ED_SKEWNESS
      INTEGER VSL_SS_ED_MIN
      INTEGER VSL_SS_ED_MAX
      INTEGER VSL_SS_ED_VARIATION
      INTEGER VSL_SS_ED_COV
      INTEGER VSL_SS_ED_COV_STORAGE
      INTEGER VSL_SS_ED_COR
      INTEGER VSL_SS_ED_COR_STORAGE
      INTEGER VSL_SS_ED_ACCUM_WEIGHT
      INTEGER VSL_SS_ED_QUANT_ORDER_N
      INTEGER VSL_SS_ED_QUANT_ORDER
      INTEGER VSL_SS_ED_QUANT_QUANTILES
      INTEGER VSL_SS_ED_ORDER_STATS
      INTEGER VSL_SS_ED_GROUP_INDC
      INTEGER VSL_SS_ED_POOLED_COV_STORAGE
      INTEGER VSL_SS_ED_POOLED_MEAN
      INTEGER VSL_SS_ED_POOLED_COV
      INTEGER VSL_SS_ED_GROUP_COV_INDC
      INTEGER VSL_SS_ED_GROUP_MEAN
      INTEGER VSL_SS_ED_GROUP_COV_STORAGE
      INTEGER VSL_SS_ED_GROUP_COV
      INTEGER VSL_SS_ED_ROBUST_COV_STORAGE
      INTEGER VSL_SS_ED_ROBUST_COV_PARAMS_N
      INTEGER VSL_SS_ED_ROBUST_COV_PARAMS
      INTEGER VSL_SS_ED_ROBUST_MEAN
      INTEGER VSL_SS_ED_ROBUST_COV
      INTEGER VSL_SS_ED_OUTLIERS_PARAMS_N
      INTEGER VSL_SS_ED_OUTLIERS_PARAMS
      INTEGER VSL_SS_ED_OUTLIERS_WEIGHT
      INTEGER VSL_SS_ED_ORDER_STATS_STORAGE
      INTEGER VSL_SS_ED_PARTIAL_COV_IDX
      INTEGER VSL_SS_ED_PARTIAL_COV
      INTEGER VSL_SS_ED_PARTIAL_COV_STORAGE
      INTEGER VSL_SS_ED_PARTIAL_COR
      INTEGER VSL_SS_ED_PARTIAL_COR_STORAGE
      INTEGER VSL_SS_ED_MI_PARAMS_N
      INTEGER VSL_SS_ED_MI_PARAMS
      INTEGER VSL_SS_ED_MI_INIT_ESTIMATES_N
      INTEGER VSL_SS_ED_MI_INIT_ESTIMATES
      INTEGER VSL_SS_ED_MI_SIMUL_VALS_N
      INTEGER VSL_SS_ED_MI_SIMUL_VALS
      INTEGER VSL_SS_ED_MI_ESTIMATES_N
      INTEGER VSL_SS_ED_MI_ESTIMATES
      INTEGER VSL_SS_ED_MI_PRIOR_N
      INTEGER VSL_SS_ED_MI_PRIOR
      INTEGER VSL_SS_ED_PARAMTR_COR
      INTEGER VSL_SS_ED_PARAMTR_COR_STORAGE
      INTEGER VSL_SS_ED_STREAM_QUANT_PARAMS_N
      INTEGER VSL_SS_ED_STREAM_QUANT_PARAMS
      INTEGER VSL_SS_ED_STREAM_QUANT_ORDER_N
      INTEGER VSL_SS_ED_STREAM_QUANT_ORDER
      INTEGER VSL_SS_ED_STREAM_QUANT_QUANTILES

      PARAMETER (VSL_SS_ED_DIMEN                  =  1)
      PARAMETER (VSL_SS_ED_OBSERV_N               =  2)
      PARAMETER (VSL_SS_ED_OBSERV                 =  3)
      PARAMETER (VSL_SS_ED_OBSERV_STORAGE         =  4)
      PARAMETER (VSL_SS_ED_INDC                   =  5)
      PARAMETER (VSL_SS_ED_WEIGHTS                =  6)
      PARAMETER (VSL_SS_ED_MEAN                   =  7)
      PARAMETER (VSL_SS_ED_2R_MOM                 =  8)
      PARAMETER (VSL_SS_ED_3R_MOM                 =  9)
      PARAMETER (VSL_SS_ED_4R_MOM                 = 10)
      PARAMETER (VSL_SS_ED_2C_MOM                 = 11)
      PARAMETER (VSL_SS_ED_3C_MOM                 = 12)
      PARAMETER (VSL_SS_ED_4C_MOM                 = 13)
      PARAMETER (VSL_SS_ED_KURTOSIS               = 14)
      PARAMETER (VSL_SS_ED_SKEWNESS               = 15)
      PARAMETER (VSL_SS_ED_MIN                    = 16)
      PARAMETER (VSL_SS_ED_MAX                    = 17)
      PARAMETER (VSL_SS_ED_VARIATION              = 18)
      PARAMETER (VSL_SS_ED_COV                    = 19)
      PARAMETER (VSL_SS_ED_COV_STORAGE            = 20)
      PARAMETER (VSL_SS_ED_COR                    = 21)
      PARAMETER (VSL_SS_ED_COR_STORAGE            = 22)
      PARAMETER (VSL_SS_ED_ACCUM_WEIGHT           = 23)
      PARAMETER (VSL_SS_ED_QUANT_ORDER_N          = 24)
      PARAMETER (VSL_SS_ED_QUANT_ORDER            = 25)
      PARAMETER (VSL_SS_ED_QUANT_QUANTILES        = 26)
      PARAMETER (VSL_SS_ED_ORDER_STATS            = 27)
      PARAMETER (VSL_SS_ED_GROUP_INDC             = 28)
      PARAMETER (VSL_SS_ED_POOLED_COV_STORAGE     = 29)
      PARAMETER (VSL_SS_ED_POOLED_MEAN            = 30)
      PARAMETER (VSL_SS_ED_POOLED_COV             = 31)
      PARAMETER (VSL_SS_ED_GROUP_COV_INDC         = 32)
      PARAMETER (VSL_SS_ED_GROUP_MEAN             = 33)
      PARAMETER (VSL_SS_ED_GROUP_COV_STORAGE      = 34)
      PARAMETER (VSL_SS_ED_GROUP_COV              = 35)
      PARAMETER (VSL_SS_ED_ROBUST_COV_STORAGE     = 36)
      PARAMETER (VSL_SS_ED_ROBUST_COV_PARAMS_N    = 37)
      PARAMETER (VSL_SS_ED_ROBUST_COV_PARAMS      = 38)
      PARAMETER (VSL_SS_ED_ROBUST_MEAN            = 39)
      PARAMETER (VSL_SS_ED_ROBUST_COV             = 40)
      PARAMETER (VSL_SS_ED_OUTLIERS_PARAMS_N      = 41)
      PARAMETER (VSL_SS_ED_OUTLIERS_PARAMS        = 42)
      PARAMETER (VSL_SS_ED_OUTLIERS_WEIGHT        = 43)
      PARAMETER (VSL_SS_ED_ORDER_STATS_STORAGE    = 44)
      PARAMETER (VSL_SS_ED_PARTIAL_COV_IDX        = 45)
      PARAMETER (VSL_SS_ED_PARTIAL_COV            = 46)
      PARAMETER (VSL_SS_ED_PARTIAL_COV_STORAGE    = 47)
      PARAMETER (VSL_SS_ED_PARTIAL_COR            = 48)
      PARAMETER (VSL_SS_ED_PARTIAL_COR_STORAGE    = 49)
      PARAMETER (VSL_SS_ED_MI_PARAMS_N            = 50)
      PARAMETER (VSL_SS_ED_MI_PARAMS              = 51)
      PARAMETER (VSL_SS_ED_MI_INIT_ESTIMATES_N    = 52)
      PARAMETER (VSL_SS_ED_MI_INIT_ESTIMATES      = 53)
      PARAMETER (VSL_SS_ED_MI_SIMUL_VALS_N        = 54)
      PARAMETER (VSL_SS_ED_MI_SIMUL_VALS          = 55)
      PARAMETER (VSL_SS_ED_MI_ESTIMATES_N         = 56)
      PARAMETER (VSL_SS_ED_MI_ESTIMATES           = 57)
      PARAMETER (VSL_SS_ED_MI_PRIOR_N             = 58)
      PARAMETER (VSL_SS_ED_MI_PRIOR               = 59)
      PARAMETER (VSL_SS_ED_PARAMTR_COR            = 60)
      PARAMETER (VSL_SS_ED_PARAMTR_COR_STORAGE    = 61)
      PARAMETER (VSL_SS_ED_STREAM_QUANT_PARAMS_N  = 62)
      PARAMETER (VSL_SS_ED_STREAM_QUANT_PARAMS    = 63)
      PARAMETER (VSL_SS_ED_STREAM_QUANT_ORDER_N   = 64)
      PARAMETER (VSL_SS_ED_STREAM_QUANT_ORDER     = 65)
      PARAMETER (VSL_SS_ED_STREAM_QUANT_QUANTILES = 66)



! SS Compute routine calculates estimates supported by the library
! Macros below define estimates to compute
       INTEGER(KIND=8) VSL_SS_MEAN
       INTEGER(KIND=8) VSL_SS_2R_MOM
       INTEGER(KIND=8) VSL_SS_3R_MOM
       INTEGER(KIND=8) VSL_SS_4R_MOM
       INTEGER(KIND=8) VSL_SS_2C_MOM
       INTEGER(KIND=8) VSL_SS_3C_MOM
       INTEGER(KIND=8) VSL_SS_4C_MOM
       INTEGER(KIND=8) VSL_SS_KURTOSIS
       INTEGER(KIND=8) VSL_SS_SKEWNESS
       INTEGER(KIND=8) VSL_SS_VARIATION
       INTEGER(KIND=8) VSL_SS_MIN
       INTEGER(KIND=8) VSL_SS_MAX
       INTEGER(KIND=8) VSL_SS_COV
       INTEGER(KIND=8) VSL_SS_COR
       INTEGER(KIND=8) VSL_SS_POOLED_COV
       INTEGER(KIND=8) VSL_SS_GROUP_COV
       INTEGER(KIND=8) VSL_SS_QUANTS
       INTEGER(KIND=8) VSL_SS_ORDER_STATS
       INTEGER(KIND=8) VSL_SS_ROBUST_COV
       INTEGER(KIND=8) VSL_SS_OUTLIERS
       INTEGER(KIND=8) VSL_SS_PARTIAL_COV
       INTEGER(KIND=8) VSL_SS_PARTIAL_COR
       INTEGER(KIND=8) VSL_SS_MISSING_VALS
       INTEGER(KIND=8) VSL_SS_PARAMTR_COR
       INTEGER(KIND=8) VSL_SS_STREAM_QUANTS
       PARAMETER ( VSL_SS_MEAN          = Z"0000000000000001" )
       PARAMETER ( VSL_SS_2R_MOM        = Z"0000000000000002" )
       PARAMETER ( VSL_SS_3R_MOM        = Z"0000000000000004" )
       PARAMETER ( VSL_SS_4R_MOM        = Z"0000000000000008" )
       PARAMETER ( VSL_SS_2C_MOM        = Z"0000000000000010" )
       PARAMETER ( VSL_SS_3C_MOM        = Z"0000000000000020" )
       PARAMETER ( VSL_SS_4C_MOM        = Z"0000000000000040" )
       PARAMETER ( VSL_SS_KURTOSIS      = Z"0000000000000080" )
       PARAMETER ( VSL_SS_SKEWNESS      = Z"0000000000000100" )
       PARAMETER ( VSL_SS_VARIATION     = Z"0000000000000200" )
       PARAMETER ( VSL_SS_MIN           = Z"0000000000000400" )
       PARAMETER ( VSL_SS_MAX           = Z"0000000000000800" )
       PARAMETER ( VSL_SS_COV           = Z"0000000000001000" )
       PARAMETER ( VSL_SS_COR           = Z"0000000000002000" )
       PARAMETER ( VSL_SS_POOLED_COV    = Z"0000000000004000" )
       PARAMETER ( VSL_SS_GROUP_COV     = Z"0000000000008000" )
       PARAMETER ( VSL_SS_QUANTS        = Z"0000000000010000" )
       PARAMETER ( VSL_SS_ORDER_STATS   = Z"0000000000020000" )
       PARAMETER ( VSL_SS_ROBUST_COV    = Z"0000000000040000" )
       PARAMETER ( VSL_SS_OUTLIERS      = Z"0000000000080000" )
       PARAMETER ( VSL_SS_PARTIAL_COV   = Z"0000000000100000" )
       PARAMETER ( VSL_SS_PARTIAL_COR   = Z"0000000000200000" )
       PARAMETER ( VSL_SS_MISSING_VALS  = Z"0000000000400000" )
       PARAMETER ( VSL_SS_PARAMTR_COR   = Z"0000000000800000" )
       PARAMETER ( VSL_SS_STREAM_QUANTS = Z"0000000001000000" )

!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!==============================================================================
!------------------------------------------------------------------------------

      INTEGER vsldconvnewtask
      EXTERNAL vsldconvnewtask

      INTEGER vslsconvnewtask
      EXTERNAL vslsconvnewtask

      INTEGER vslzconvnewtask
      EXTERNAL vslzconvnewtask

      INTEGER vslcconvnewtask
      EXTERNAL vslcconvnewtask

      INTEGER vsldcorrnewtask
      EXTERNAL vsldcorrnewtask

      INTEGER vslscorrnewtask
      EXTERNAL vslscorrnewtask

      INTEGER vslzcorrnewtask
      EXTERNAL vslzcorrnewtask

      INTEGER vslccorrnewtask
      EXTERNAL vslccorrnewtask

      INTEGER vsldconvnewtask1d
      EXTERNAL vsldconvnewtask1d

      INTEGER vslsconvnewtask1d
      EXTERNAL vslsconvnewtask1d

      INTEGER vslzconvnewtask1d
      EXTERNAL vslzconvnewtask1d

      INTEGER vslcconvnewtask1d
      EXTERNAL vslcconvnewtask1d

      INTEGER vsldcorrnewtask1d
      EXTERNAL vsldcorrnewtask1d

      INTEGER vslscorrnewtask1d
      EXTERNAL vslscorrnewtask1d

      INTEGER vslzcorrnewtask1d
      EXTERNAL vslzcorrnewtask1d

      INTEGER vslccorrnewtask1d
      EXTERNAL vslccorrnewtask1d

      INTEGER vsldconvnewtaskx
      EXTERNAL vsldconvnewtaskx

      INTEGER vslsconvnewtaskx
      EXTERNAL vslsconvnewtaskx

      INTEGER vslzconvnewtaskx
      EXTERNAL vslzconvnewtaskx

      INTEGER vslcconvnewtaskx
      EXTERNAL vslcconvnewtaskx

      INTEGER vsldcorrnewtaskx
      EXTERNAL vsldcorrnewtaskx

      INTEGER vslscorrnewtaskx
      EXTERNAL vslscorrnewtaskx

      INTEGER vslzcorrnewtaskx
      EXTERNAL vslzcorrnewtaskx

      INTEGER vslccorrnewtaskx
      EXTERNAL vslccorrnewtaskx

      INTEGER vsldconvnewtaskx1d
      EXTERNAL vsldconvnewtaskx1d

      INTEGER vslsconvnewtaskx1d
      EXTERNAL vslsconvnewtaskx1d

      INTEGER vslzconvnewtaskx1d
      EXTERNAL vslzconvnewtaskx1d

      INTEGER vslcconvnewtaskx1d
      EXTERNAL vslcconvnewtaskx1d

      INTEGER vsldcorrnewtaskx1d
      EXTERNAL vsldcorrnewtaskx1d

      INTEGER vslscorrnewtaskx1d
      EXTERNAL vslscorrnewtaskx1d

      INTEGER vslzcorrnewtaskx1d
      EXTERNAL vslzcorrnewtaskx1d

      INTEGER vslccorrnewtaskx1d
      EXTERNAL vslccorrnewtaskx1d

      INTEGER vslconvdeletetask
      EXTERNAL vslconvdeletetask

      INTEGER vslcorrdeletetask
      EXTERNAL vslcorrdeletetask

      INTEGER vslconvcopytask
      EXTERNAL vslconvcopytask

      INTEGER vslcorrcopytask
      EXTERNAL vslcorrcopytask

      INTEGER vslConvSetMode
      EXTERNAL vslConvSetMode

      INTEGER vslCorrSetMode
      EXTERNAL vslCorrSetMode

      INTEGER vslConvSetInternalPrecision
      EXTERNAL vslConvSetInternalPrecision

      INTEGER vslCorrSetInternalPrecision
      EXTERNAL vslCorrSetInternalPrecision

      INTEGER vslConvSetStart
      EXTERNAL vslConvSetStart

      INTEGER vslCorrSetStart
      EXTERNAL vslCorrSetStart

      INTEGER vslConvSetDecimation
      EXTERNAL vslConvSetDecimation

      INTEGER vslCorrSetDecimation
      EXTERNAL vslCorrSetDecimation


      INTEGER vsldconvexec
      EXTERNAL vsldconvexec

      INTEGER vslsconvexec
      EXTERNAL vslsconvexec

      INTEGER vslzconvexec
      EXTERNAL vslzconvexec

      INTEGER vslcconvexec
      EXTERNAL vslcconvexec

      INTEGER vsldcorrexec
      EXTERNAL vsldcorrexec

      INTEGER vslscorrexec
      EXTERNAL vslscorrexec

      INTEGER vslzcorrexec
      EXTERNAL vslzcorrexec

      INTEGER vslccorrexec
      EXTERNAL vslccorrexec

      INTEGER vsldconvexec1d
      EXTERNAL vsldconvexec1d

      INTEGER vslsconvexec1d
      EXTERNAL vslsconvexec1d

      INTEGER vslzconvexec1d
      EXTERNAL vslzconvexec1d

      INTEGER vslcconvexec1d
      EXTERNAL vslcconvexec1d

      INTEGER vsldcorrexec1d
      EXTERNAL vsldcorrexec1d

      INTEGER vslscorrexec1d
      EXTERNAL vslscorrexec1d

      INTEGER vslzcorrexec1d
      EXTERNAL vslzcorrexec1d

      INTEGER vslccorrexec1d
      EXTERNAL vslccorrexec1d

      INTEGER vsldconvexecx
      EXTERNAL vsldconvexecx

      INTEGER vslsconvexecx
      EXTERNAL vslsconvexecx

      INTEGER vslzconvexecx
      EXTERNAL vslzconvexecx

      INTEGER vslcconvexecx
      EXTERNAL vslcconvexecx

      INTEGER vsldcorrexecx
      EXTERNAL vsldcorrexecx

      INTEGER vslscorrexecx
      EXTERNAL vslscorrexecx

      INTEGER vslzcorrexecx
      EXTERNAL vslzcorrexecx

      INTEGER vslccorrexecx
      EXTERNAL vslccorrexecx

      INTEGER vsldconvexecx1d
      EXTERNAL vsldconvexecx1d

      INTEGER vslsconvexecx1d
      EXTERNAL vslsconvexecx1d

      INTEGER vslzconvexecx1d
      EXTERNAL vslzconvexecx1d

      INTEGER vslcconvexecx1d
      EXTERNAL vslcconvexecx1d

      INTEGER vsldcorrexecx1d
      EXTERNAL vsldcorrexecx1d

      INTEGER vslscorrexecx1d
      EXTERNAL vslscorrexecx1d

      INTEGER vslzcorrexecx1d
      EXTERNAL vslzcorrexecx1d

      INTEGER vslccorrexecx1d
      EXTERNAL vslccorrexecx1d

!++
!  VSL CONTINUOUS DISTRIBUTION GENERATOR INTERFACES.
!--

!  Uniform distribution

      INTEGER vsrnguniform
      INTEGER vdrnguniform
      EXTERNAL vsrnguniform
      EXTERNAL vdrnguniform

!  Gaussian distribution

      INTEGER vsrnggaussian
      INTEGER vdrnggaussian
      EXTERNAL vsrnggaussian
      EXTERNAL vdrnggaussian

!  GaussianMV distribution

      INTEGER vsrnggaussianmv
      INTEGER vdrnggaussianmv
      EXTERNAL vsrnggaussianmv
      EXTERNAL vdrnggaussianmv

!  Exponential distribution

      INTEGER vsrngexponential
      INTEGER vdrngexponential
      EXTERNAL vsrngexponential
      EXTERNAL vdrngexponential

!  Laplace distribution

      INTEGER vsrnglaplace
      INTEGER vdrnglaplace
      EXTERNAL vsrnglaplace
      EXTERNAL vdrnglaplace

!  Weibull distribution

      INTEGER vsrngweibull
      INTEGER vdrngweibull
      EXTERNAL vsrngweibull
      EXTERNAL vdrngweibull

!  Cauchy distribution

      INTEGER vsrngcauchy
      INTEGER vdrngcauchy
      EXTERNAL vsrngcauchy
      EXTERNAL vdrngcauchy

!  Rayleigh distribution

      INTEGER vsrngrayleigh
      INTEGER vdrngrayleigh
      EXTERNAL vsrngrayleigh
      EXTERNAL vdrngrayleigh

!  Lognormal distribution

      INTEGER vsrnglognormal
      INTEGER vdrnglognormal
      EXTERNAL vsrnglognormal
      EXTERNAL vdrnglognormal

!  Gumbel distribution

      INTEGER vsrnggumbel
      INTEGER vdrnggumbel
      EXTERNAL vsrnggumbel
      EXTERNAL vdrnggumbel

!  Gamma distribution

      INTEGER vsrnggamma
      INTEGER vdrnggamma
      EXTERNAL vsrnggamma
      EXTERNAL vdrnggamma

!  Beta distribution

      INTEGER vsrngbeta
      INTEGER vdrngbeta
      EXTERNAL vsrngbeta
      EXTERNAL vdrngbeta

!++
!  VSL DISCRETE DISTRIBUTION GENERATOR INTERFACES.
!--

!  Uniform distribution

      INTEGER virnguniform
      EXTERNAL virnguniform

!  UniformBits distribution

      INTEGER virnguniformbits
      EXTERNAL virnguniformbits

!  Bernoulli distribution

      INTEGER virngbernoulli
      EXTERNAL virngbernoulli

!  Geometric distribution

      INTEGER virnggeometric
      EXTERNAL virnggeometric

!  Binomial distribution

      INTEGER virngbinomial
      EXTERNAL virngbinomial

!  Hypergeometric distribution

      INTEGER virnghypergeometric
      EXTERNAL virnghypergeometric

!  Poisson distribution

      INTEGER virngpoisson
      EXTERNAL virngpoisson

!  PoissonV distribution

      INTEGER virngpoissonv
      EXTERNAL virngpoissonv

!  Negbinomial distribution

      INTEGER virngnegbinomial
      EXTERNAL virngnegbinomial

!++
!  VSL SERVICE INTERFACES.
!--

! NewStream - stream creation/initialization

      INTEGER vslnewstream
      EXTERNAL vslnewstream

! NewStreamEx - advanced stream creation/initialization

      INTEGER vslnewstreamex
      EXTERNAL vslnewstreamex

!    INEWABSTRACTSTREAM

      INTEGER vslinewabstractstream
      EXTERNAL vslinewabstractstream

!    DNEWABSTRACTSTREAM

      INTEGER vsldnewabstractstream
      EXTERNAL vsldnewabstractstream

!    SNEWABSTRACTSTREAM

      INTEGER vslsnewabstractstream
      EXTERNAL vslsnewabstractstream

! DeleteStream - delete stream

      INTEGER vsldeletestream
      EXTERNAL vsldeletestream

! CopyStream - copy all stream information

      INTEGER vslcopystream
      EXTERNAL vslcopystream

! CopyStreamState - copy stream state only

      INTEGER vslcopystreamstate
      EXTERNAL vslcopystreamstate

! LeapfrogStream - leapfrog method

      INTEGER vslleapfrogstream
      EXTERNAL vslleapfrogstream

! SkipAheadStream - skip-ahead method

      INTEGER vslskipaheadstream
      EXTERNAL vslskipaheadstream

! GetBrngProperties - get BRNG properties

      INTEGER vslgetbrngproperties
      EXTERNAL vslgetbrngproperties

! GetNumRegBrngs - get number of registered BRNGs

      INTEGER vslgetnumregbrngs
      EXTERNAL vslgetnumregbrngs

! SaveStreamF - save stream to file

      INTEGER vslsavestreamf
      EXTERNAL vslsavestreamf

! LoadStreamF - save stream to file

      INTEGER vslloadstreamf
      EXTERNAL vslloadstreamf

!++
!  SUMMARARY STATTISTICS LIBARY ROUTINES
!--

!  Task constructors
       INTEGER vsldssnewtask
       INTEGER vslsssnewtask
       EXTERNAL vsldssnewtask
       EXTERNAL vslsssnewtask

!  Task editors

!  Editor to modify a task parameter
       INTEGER vsldssedittask
       INTEGER vslsssedittask
       INTEGER vslissedittask
       EXTERNAL vsldssedittask
       EXTERNAL vslsssedittask
       EXTERNAL vslissedittask

!  Task specific editors
       INTEGER vsldsseditmoments
       INTEGER vslssseditmoments
       EXTERNAL vsldsseditmoments
       EXTERNAL vslssseditmoments

!  Editors to modify variance-covariance/correlation matrix
!  related parameters
       INTEGER vsldsseditcovcor
       INTEGER vslssseditcovcor
       EXTERNAL vsldsseditcovcor
       EXTERNAL vslssseditcovcor

!  Editors to modify partial variance-covariance matrix
!  related parameters
       INTEGER FUNCTION vsldsseditpartialcovcor
       INTEGER FUNCTION vslssseditpartialcovcor
       EXTERNAL FUNCTION vsldsseditpartialcovcor
       EXTERNAL FUNCTION vslssseditpartialcovcor

!  Editors to modify quantiles related parameters
       INTEGER vsldsseditquantiles
       INTEGER vslssseditquantiles
       EXTERNAL vsldsseditquantiles
       EXTERNAL vslssseditquantiles

!  Editors to modify stream data quantiles related parameters
       INTEGER vsldsseditstreamquantiles
       INTEGER vslssseditstreamquantiles
       EXTERNAL vsldsseditstreamquantiles
       EXTERNAL vslssseditstreamquantiles

!  Editors to modify pooled/group variance-covariance matrix
!  related parameters
       INTEGER vsldsseditpooledcovariance
       INTEGER vslssseditpooledcovariance
       EXTERNAL vsldsseditpooledcovariance
       EXTERNAL vslssseditpooledcovariance

!  Editors to modify robust variance-covariance matrix
!  related parameters
       INTEGER vsldsseditrobustcovariance
       INTEGER vslssseditrobustcovariance
       EXTERNAL vsldsseditrobustcovariance
       EXTERNAL vslssseditrobustcovariance

!  Editors to modify outliers detection parameters
        INTEGER vsldsseditoutliersdetection
        INTEGER vslssseditoutliersdetection
        EXTERNAL vsldsseditoutliersdetection
        EXTERNAL vslssseditoutliersdetection

!  Editors to modify missing values parameters
        INTEGER vsldsseditmissingvalues
        INTEGER vslssseditmissingvalues
        EXTERNAL vsldsseditmissingvalues
        EXTERNAL vslssseditmissingvalues

!     Editors to modify matrix parameterization 
!     related parameters
       INTEGER vsldsseditcorparameterization
       INTEGER vslssseditcorparameterization
       EXTERNAL vsldsseditcorparameterization
       EXTERNAL vslssseditcorparameterization

!  Compute routines
        INTEGER vsldsscompute
        INTEGER vslssscompute
        EXTERNAL vsldsscompute
        EXTERNAL vslssscompute

!  Task destructor
        INTEGER vslssdeletetask
        EXTERNAL vslssdeletetask
